=== added directory '.be/bugs/4ddc9130-fe72-4d0c-9848-157ad6f2c14d'
=== added file '.be/bugs/4ddc9130-fe72-4d0c-9848-157ad6f2c14d/values'
--- .be/bugs/4ddc9130-fe72-4d0c-9848-157ad6f2c14d/values	1970-01-01 00:00:00 +0000
+++ .be/bugs/4ddc9130-fe72-4d0c-9848-157ad6f2c14d/values	2005-09-23 03:08:27 +0000
@@ -0,0 +1,42 @@
+
+
+
+assigned=abentley
+
+
+
+
+
+
+creator=abentley
+
+
+
+
+
+
+severity=minor
+
+
+
+
+
+
+status=closed
+
+
+
+
+
+
+summary=push overwrites diverged branches
+
+
+
+
+
+
+time=Tue, 20 Sep 2005 17:08:01 +0000
+
+
+

=== added directory '.be/bugs/7c3b4f3e-33c5-4112-b8df-c209ec6cc8b6'
=== added file '.be/bugs/7c3b4f3e-33c5-4112-b8df-c209ec6cc8b6/values'
--- .be/bugs/7c3b4f3e-33c5-4112-b8df-c209ec6cc8b6/values	1970-01-01 00:00:00 +0000
+++ .be/bugs/7c3b4f3e-33c5-4112-b8df-c209ec6cc8b6/values	2005-09-23 03:08:27 +0000
@@ -0,0 +1,42 @@
+
+
+
+assigned=abentley
+
+
+
+
+
+
+creator=abentley
+
+
+
+
+
+
+severity=minor
+
+
+
+
+
+
+status=closed
+
+
+
+
+
+
+summary=push overwrites existing non-bzr directories
+
+
+
+
+
+
+time=Tue, 20 Sep 2005 17:07:14 +0000
+
+
+

=== added file '.bzrignore'
--- .bzrignore	1970-01-01 00:00:00 +0000
+++ .bzrignore	2005-10-26 14:34:44 +0000
@@ -0,0 +1,12 @@
+.*.swp
+.*.swo
+./bzrlib
+./pybaz
+debian/bzrtools
+debian/bzrtools.substvars
+debian/files
+debian/stamp-patched
+,,*
+./build
+bzrlib
+test

=== removed file '.bzrignore'
--- .bzrignore	2005-06-09 00:49:58 +0000
+++ .bzrignore	1970-01-01 00:00:00 +0000
@@ -1,8 +0,0 @@
-.*.swp
-.*.swo
-./bzrlib
-./pybaz
-debian/bzrtools
-debian/bzrtools.substvars
-debian/files
-debian/stamp-patched

=== modified file 'INSTALL'
--- INSTALL	2005-08-26 00:35:32 +0000
+++ INSTALL	2005-10-24 13:30:14 +0000
@@ -1,10 +1,15 @@
 How to install bzrtools:
 All the tools are plugins, so you can install them in your plugins directory.
+IT IS IMPORTANT TO MOVE/COPY THE BZRTOOLS DIRECTORY, NOT ITS CONTENTS.
 
-$ mv ~/bzrtools ~/.bzr.conf/plugins/
+$ mv ~/bzrtools ~/.bazaar/plugins/
 You may have to create the plugins directory first.
 
-You can test whether they are successfully installed by doing "bzr annotate -h"
+Alternatively, you can install them at the system-wide plugin location:
+$ sudo python2.4 setup.py install
+
+You can test whether they are successfully installed by doing 
+"bzr clean-tree -h"
 
 If you want to use baz-import, stick a pybaz symlink in the bzrtools tree:
 $ baz register-archive http://ddaa.net/arch/2004

=== modified file 'NEWS'
--- NEWS	2005-09-13 22:49:40 +0000
+++ NEWS	2005-10-28 04:43:36 +0000
@@ -1,3 +1,35 @@
+Oct 28
+* Added tests for several commands
+* Made push auto_disable when native push present
+* Merged Michael Ellerman's shelf v2 plugin 
+* New "shell" command, derived from Fai
+* Got pull working with URLs
+
+Oct 19
+* Added setup.py
+* disabled annotate in favor of bzr annotate
+* Added clean-tree --detrius
+* API sync with bzr
+
+Oct 14
+* Default-ignore shelf files
+* Win32 compatability fixes (Alexander Belchenko)
+* Conflict handling now in bzr itself
+* Fetch-missing renamed to fetch-ghosts
+* Annotate includes changes since last commit, uses sha1 instead of text_id
+
+Sept 29
+* better errors for bad push locations (Eirik Nygaard)
+* prevented push from overwriting any non-empty directory that is not an
+  ancestor branch.  (Remote revision-history must be a subset of local.)
+* added --overwrite option to push
+
+Sept 22
+* Significant reworking of graph-ancestry
+* Fetch-missing uses 'parent' instead of 'x-pull' (bzr changed)
+* Updated to match bzr 0.0.8 API changes
+* Updated to handle new bzr diff output
+
 Sept 13
 * documented clean-tree, conflicts, resolve, graph-ancestry, patch
 * obsoleted all the executibles; bzrtools only works as plugins now

=== removed file '__init__.py'
--- __init__.py	2005-09-11 03:28:31 +0000
+++ __init__.py	1970-01-01 00:00:00 +0000
@@ -1,103 +0,0 @@
-"""\
-Various useful plugins for working with bzr.
-"""
-import bzrlib.commands
-import push
-import annotate
-import shelf
-import conflicts
-import sys
-import os.path
-sys.path.append(os.path.dirname(__file__))
-
-bzrlib.commands.OPTIONS['ignored'] = None
-
-class cmd_clean_tree(bzrlib.commands.Command):
-    """Remove unwanted files from working tree.
-    Normally, ignored files are left alone.  The --ignored flag will cause them
-    to be deleted as well.
-    """
-    takes_options = ['ignored']
-    def run(self, ignored=False):
-        import clean_tree
-        clean_tree.clean_tree(ignored=ignored)
-
-class cmd_conflicted(bzrlib.commands.Command):
-    """List files that have conflicts
-    """
-    takes_options = ['ignored']
-    def run(self, ignored=False):
-        import clean_tree
-        clean_tree.clean_tree(ignored=ignored)
-
-bzrlib.commands.OPTIONS['no-collapse'] = None
-bzrlib.commands.OPTIONS['no-antialias'] = None
-
-class cmd_graph_ancestry(bzrlib.commands.Command):
-    """Produce ancestry graphs using dot.
-    
-    Output format is detected according to file extension.  Some of the more
-    common output formats are png, gif, svg, ps.  An extension of '.dot' will
-    cause a dot graph file to be produced.
-
-    Ancestry is usually collapsed by removing nodes with a single parent
-    and descendant, but this can be disabled with --no-collapse.
-
-    The current branch's revisions are yellow and labeled R?, where ? is
-    the revno.  Other revisions are labeled with essentially random numbers.
-
-    Revisions that are not in branch storage have dotted outlines.
-
-    rsvg is used to antialias PNG and JPEG output, but this can be disabled
-    with --no-antialias.
-    """
-    takes_args = ['branch', 'file']
-    takes_options = ['no-collapse', 'no-antialias']
-    def run(self, branch, file, no_collapse=False, no_antialias=False):
-        import graph
-        graph.write_ancestry_file(branch, file, not no_collapse, 
-                                  not no_antialias)
-
-class cmd_fetch_missing(bzrlib.commands.Command):
-    """Attempt to retrieve missing ancestors from another branch.
-    If the other branch is not supplied, the last-pulled branch is used.
-    """
-    takes_args = ['branch?']
-    def run(self, branch=None):
-        from fetch_missing import fetch_missing
-        fetch_missing(branch)
-
-class cmd_patch(bzrlib.commands.Command):
-    """Apply a named patch to the current tree.
-    """
-    takes_args = ['filename?']
-    takes_options = ['strip']
-    def run(self, filename=None, strip=0):
-        from patch import patch
-        from bzrlib.branch import Branch
-        b = Branch('.', find_root=True)
-        return patch(b, filename, strip)
-
-
-
-commands = [push.cmd_push, annotate.cmd_annotate, shelf.cmd_shelve, 
-            shelf.cmd_unshelve, cmd_clean_tree, conflicts.cmd_conflicts,
-            conflicts.cmd_resolve, cmd_graph_ancestry, cmd_fetch_missing,
-            cmd_patch]
-from errors import NoPyBaz
-try:
-    import baz_import
-    commands.append(baz_import.cmd_baz_import)
-
-except NoPyBaz:
-    class cmd_baz_import(bzrlib.commands.Command):
-        """Disabled. (Requires PyBaz)"""
-    commands.append(cmd_baz_import)
-
-if hasattr(bzrlib.commands, 'register_command'):
-    for command in commands:
-        bzrlib.commands.register_command(command)
-
-def test_suite():
-    from doctest import DocTestSuite
-    return DocTestSuite(bzrtools)

=== added file '__init__.py'
--- __init__.py	1970-01-01 00:00:00 +0000
+++ __init__.py	2005-10-27 04:45:06 +0000
@@ -0,0 +1,184 @@
+#!/usr/bin/python
+"""\
+Various useful plugins for working with bzr.
+"""
+import bzrlib.commands
+import push
+import annotate
+from shelf import Shelf
+import sys
+import os.path
+from bzrlib.option import Option
+import bzrlib.branch
+from bzrlib.errors import BzrCommandError
+sys.path.append(os.path.dirname(__file__))
+
+Option.OPTIONS['ignored'] = Option('ignored',
+        help='delete all ignored files.')
+Option.OPTIONS['detrius'] = Option('detrius',
+        help='delete conflict files merge backups, and failed selftest dirs.' +
+              '(*.THIS, *.BASE, *.OTHER, *~, *.tmp')
+Option.OPTIONS['dry-run'] = Option('dry-run',
+        help='show files to delete instead of deleting them.')
+
+class cmd_clean_tree(bzrlib.commands.Command):
+    """Remove unwanted files from working tree.
+    Normally, ignored files are left alone.
+    """
+    takes_options = ['ignored', 'detrius', 'dry-run']
+    def run(self, ignored=False, detrius=False, dry_run=False):
+        from clean_tree import clean_tree
+        clean_tree('.', ignored=ignored, detrius=detrius, dry_run=dry_run)
+
+Option.OPTIONS['no-collapse'] = Option('no-collapse')
+Option.OPTIONS['no-antialias'] = Option('no-antialias')
+Option.OPTIONS['cluster'] = Option('cluster')
+Option.OPTIONS['merge-branch'] = Option('merge-branch',type=str)
+
+class cmd_graph_ancestry(bzrlib.commands.Command):
+    """Produce ancestry graphs using dot.
+    
+    Output format is detected according to file extension.  Some of the more
+    common output formats are png, gif, svg, ps.  An extension of '.dot' will
+    cause a dot graph file to be produced.
+
+    Branches are labeled r?, where ? is the revno.  If they have no revno,
+    with the last 5 characters of their revision identifier are used instead.
+    
+    If --merge-branch is specified, the two branches are compared and a merge
+    base is selected.
+    
+    Legend:
+    white    normal revision
+    yellow   THIS  history
+    red      OTHER history
+    orange   COMMON history
+    blue     COMMON non-history ancestor
+    dotted   Missing from branch storage
+
+    Ancestry is usually collapsed by removing revisions with a single parent
+    and descendant.  The number of skipped revisions is shown on the arrow.
+    This feature can be disabled with --no-collapse.
+
+    By default, revisions are ordered by distance from root, but they can be
+    clustered instead using --cluster.
+
+    If available, rsvg is used to antialias PNG and JPEG output, but this can
+    be disabled with --no-antialias.
+    """
+    takes_args = ['branch', 'file']
+    takes_options = ['no-collapse', 'no-antialias', 'merge-branch', 'cluster']
+    def run(self, branch, file, no_collapse=False, no_antialias=False,
+        merge_branch=None, cluster=False):
+        import graph
+        if cluster:
+            ranking = "cluster"
+        else:
+            ranking = "forced"
+        graph.write_ancestry_file(branch, file, not no_collapse, 
+                                  not no_antialias, merge_branch, ranking)
+
+class cmd_fetch_ghosts(bzrlib.commands.Command):
+    """Attempt to retrieve ghosts from another branch.
+    If the other branch is not supplied, the last-pulled branch is used.
+    """
+    aliases = ['fetch-missing']
+    takes_args = ['branch?']
+    def run(self, branch=None):
+        from fetch_ghosts import fetch_ghosts
+        fetch_ghosts(branch)
+
+strip_help="""Strip the smallest prefix containing num leading slashes  from \
+each file name found in the patch file."""
+Option.OPTIONS['strip'] = Option('strip', type=int, help=strip_help)
+class cmd_patch(bzrlib.commands.Command):
+    """Apply a named patch to the current tree.
+    """
+    takes_args = ['filename?']
+    takes_options = ['strip']
+    def run(self, filename=None, strip=0):
+        from patch import patch
+        from bzrlib.branch import Branch
+        b = Branch.open_containing('.')[0]
+        return patch(b, filename, strip)
+
+
+class cmd_shelve(bzrlib.commands.Command):
+    """Temporarily remove some changes from the current tree.
+    Use 'unshelve' to restore these changes.
+
+    If filenames are specified, only changes to those files will be unshelved.
+    If a revision is specified, all changes since that revision will may be
+    unshelved.
+    """
+    takes_args = ['file*']
+    takes_options = ['all', 'message', 'revision']
+    def run(self, all=False, file_list=None, message=None, revision=None):
+        if file_list is not None and len(file_list) > 0:
+            branchdir = file_list[0]
+        else:
+            branchdir = '.'
+
+        if revision is not None and revision:
+            if len(revision) == 1:
+                revision = revision[0]
+            else:
+                raise BzrCommandError("shelve only accepts a single revision "
+                                  "parameter.")
+
+        s = Shelf(branchdir)
+        return s.shelve(all, message, revision, file_list)
+
+
+class cmd_unshelve(bzrlib.commands.Command):
+    """Restore previously-shelved changes to the current tree.
+    See also 'shelve'.
+    """
+    def run(self):
+        s = Shelf('.')
+        return s.unshelve()
+
+class cmd_shell(bzrlib.commands.Command):
+    def run(self):
+        import shell
+        shell.run_shell()
+
+commands = [cmd_shelve, cmd_unshelve, cmd_clean_tree, cmd_graph_ancestry,
+            cmd_fetch_ghosts, cmd_patch, cmd_shell]
+
+import bzrlib.builtins
+if not hasattr(bzrlib.builtins, "cmd_annotate"):
+    commands.append(annotate.cmd_annotate)
+if not hasattr(bzrlib.builtins, "cmd_push"):
+    commands.append(push.cmd_push)
+
+from errors import NoPyBaz
+try:
+    import baz_import
+    commands.append(baz_import.cmd_baz_import)
+
+except NoPyBaz:
+    class cmd_baz_import(bzrlib.commands.Command):
+        """Disabled. (Requires PyBaz)"""
+        takes_args = ['to_root_dir?', 'from_archive?']
+        takes_options = ['verbose']
+        def run(self, to_root_dir=None, from_archive=None, verbose=False):
+            print "This command is disabled.  Please install PyBaz."
+    commands.append(cmd_baz_import)
+
+if hasattr(bzrlib.commands, 'register_command'):
+    for command in commands:
+        bzrlib.commands.register_command(command)
+
+def test_suite():
+    from doctest import DocTestSuite
+    from unittest import TestSuite, TestLoader
+    import clean_tree
+    import blackbox
+    import shelf_tests
+    result = TestSuite()
+    result.addTest(DocTestSuite(bzrtools))
+    result.addTest(clean_tree.test_suite())
+    result.addTest(TestLoader().loadTestsFromModule(shelf_tests))
+    result.addTest(blackbox.test_suite())
+    return result

=== modified file 'annotate.py'
--- annotate.py	2005-08-26 00:15:55 +0000
+++ annotate.py	2005-10-18 20:17:59 +0000
@@ -25,28 +25,34 @@
 import sys
 
 def iter_anno_data(branch, file_id):
-    later_revision = branch.revno()
-    q = range(branch.revno())
+    max_revno = branch.revno()
+    later_revision = max_revno
+    q = range(max_revno)
+    q.append(max_revno)
     q.reverse()
-    later_text_id = branch.basis_tree().inventory[file_id].text_id
+    next_tree = branch.working_tree()
+    later_text_sha1 = next_tree.get_file_sha1(file_id)
     i = 0
     for revno in q:
         i += 1
-        cur_tree = branch.revision_tree(branch.lookup_revision(revno))
+        cur_tree = branch.revision_tree(branch.get_rev_id(revno))
         if file_id not in cur_tree.inventory:
-            text_id = None
+            text_sha1 = None
         else:
-            text_id = cur_tree.inventory[file_id].text_id
-        if text_id != later_text_id:
-            patch = get_patch(branch, revno, later_revision, file_id)
-            yield revno, patch.iter_inserted(), patch
+            text_sha1 = cur_tree.get_file_sha1(file_id)
+        if text_sha1 != later_text_sha1:
+            patch = get_patch(branch, cur_tree, next_tree, file_id)
+            next_tree = cur_tree
+            if revno == max_revno:
+                display_id = "Tree"
+            else:
+                display_id = str(revno+1)
+            yield display_id, patch.iter_inserted(), patch
             later_revision = revno
-            later_text_id = text_id
+            later_text_sha1 = text_sha1
         yield progress.Progress("revisions", i)
 
-def get_patch(branch, old_revno, new_revno, file_id):
-    old_tree = branch.revision_tree(branch.lookup_revision(old_revno))
-    new_tree = branch.revision_tree(branch.lookup_revision(new_revno))
+def get_patch(branch, old_tree, new_tree, file_id):
     if file_id in old_tree.inventory:
         old_file = old_tree.get_file(file_id).readlines()
     else:
@@ -61,7 +67,7 @@
     def run(self, filename):
         if not os.path.exists(filename):
             raise BzrCommandError("The file %s does not exist." % filename)
-        branch = (Branch(filename))
+        branch = (Branch.open_containing(filename))[0]
         file_id = branch.working_tree().path2id(branch.relpath(filename))
         if file_id is None:
             raise BzrCommandError("The file %s is not versioned." % filename)

=== modified file 'baz_import.py'
--- baz_import.py	2005-08-30 19:32:49 +0000
+++ baz_import.py	2005-10-15 00:25:39 +0000
@@ -206,7 +206,7 @@
     return ancestors
 
 def get_last_revision(branch):
-    last_patch = branch.last_patch()
+    last_patch = branch.last_revision()
     try:
         return arch_revision(last_patch)
     except NotArchRevision:
@@ -437,7 +437,7 @@
                 # next revision of the baz tree
                 branch = find_branch(revdir)
             else:
-                branch = Branch(revdir, init=True)
+                branch = Branch.initialize(revdir)
         else:
             old = os.path.join(revdir, ".bzr")
             new = os.path.join(tempdir, ".bzr")
@@ -544,7 +544,7 @@
     True
     """
     try:
-        return Branch(path)
+        return Branch.open(path)
     except BzrError, e:
         if e.args[0].endswith("' is not in a branch"):
             raise NotInABranch(path)

=== added file 'blackbox.py'
--- blackbox.py	1970-01-01 00:00:00 +0000
+++ blackbox.py	2005-10-24 04:39:58 +0000
@@ -0,0 +1,47 @@
+from bzrlib.selftest.blackbox import ExternalBase
+from unittest import makeSuite
+import os.path
+class TestBzrTools(ExternalBase):
+    @staticmethod
+    def touch(filename):
+        file(filename, 'wb').write('')
+
+    def test_clean_tree(self):
+        self.runbzr('init')
+        self.touch('name')
+        self.touch('name~')
+        assert os.path.lexists('name~')
+        self.touch('name.pyc')
+        self.runbzr('clean-tree')
+        assert os.path.lexists('name~')
+        assert not os.path.lexists('name')
+        self.runbzr('clean-tree --detrius')
+        assert not os.path.lexists('name~')
+        assert os.path.lexists('name.pyc')
+        self.runbzr('clean-tree --ignored')
+        assert not os.path.lexists('name.pyc')
+
+    def test_shelve(self):
+        self.runbzr('init')
+        self.runbzr('commit -m uc --unchanged')
+        self.runbzr('shelve -r 1 -m foo', retcode=1)
+
+    def test_fetch_ghosts(self):
+        self.runbzr('init')
+        self.runbzr('fetch-ghosts .', retcode=1)
+
+    def test_patch(self):
+        self.runbzr('init')
+        file('myfile', 'wb').write('hello')
+        self.runbzr('add')
+        self.runbzr('commit -m hello')
+        file('myfile', 'wb').write('goodbye')
+        file('mypatch', 'wb').write(self.runbzr('diff', backtick=1))
+        self.runbzr('revert')
+        assert file('myfile', 'rb').read() == 'hello'
+        self.runbzr('patch mypatch')
+        assert file('myfile', 'rb').read() == 'goodbye'
+
+
+def test_suite():
+    return makeSuite(TestBzrTools)

=== modified file 'bzrtools.py'
--- bzrtools.py	2005-09-07 12:51:20 +0000
+++ bzrtools.py	2005-10-29 21:29:55 +0000
@@ -15,16 +15,19 @@
 #    along with this program; if not, write to the Free Software
 #    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 import bzrlib
+import bzrlib.errors
 import os
 import os.path
 import sys
 import tempfile
 import shutil
+import errno
 from subprocess import Popen, PIPE
+import codecs
 
 def temp_branch():
     dirname = tempfile.mkdtemp("temp-branch")
-    return bzrlib.branch.Branch(dirname, init=True)
+    return bzrlib.branch.Branch.initialize(dirname)
 
 def rm_branch(br):
     shutil.rmtree(br.base)
@@ -39,13 +42,12 @@
     >>> fooname = os.path.join(br.base, "foo")
     >>> file(fooname, "wb").write("bar")
     >>> is_clean(br)
-    (True, ['foo'])
+    (True, [u'foo'])
     >>> bzrlib.add.smart_add_branch(br, [br.base])
     1
     >>> is_clean(br)
     (False, [])
     >>> br.commit("added file")
-    added foo
     >>> is_clean(br)
     (True, [])
     >>> rm_branch(br)
@@ -54,14 +56,11 @@
     old_tree = cur_branch.basis_tree()
     new_tree = cur_branch.working_tree()
     non_source = []
-    for path, file_class, kind, file_id in new_tree.list_files():
+    for path, file_class, kind, file_id, entry in new_tree.list_files():
         if file_class in ('?', 'I'):
             non_source.append(path)
     delta = compare_trees(old_tree, new_tree, want_unchanged=False)
-    if len(delta.added) > 0 or len(delta.removed) > 0 or \
-        len(delta.modified) > 0:
-        return False, non_source
-    return True, non_source 
+    return not delta.has_changed(), non_source
 
 def set_pull_data(br, location, rev_id):
     pull_file = file (br.controlfilename("x-pull-data"), "wb")
@@ -123,32 +122,132 @@
     arg_str = " ".join([shell_escape(a) for a in args])
     return os.system(arg_str)
 
-def rsync(source, target, ssh=False, excludes=()):
-    """
-    >>> real_system = os.system
-    >>> os.system = sys.stdout.write
-    >>> rsync("a", "b")
-    ['rsync', '-av', '--delete', 'a', 'b']
-    >>> rsync("a", "b", excludes=("*.py",))
-    ['rsync', '-av', '--delete', '--exclude-from', '-', 'a', 'b']
-    >>> os.system = real_system
-    """
-    cmd = ["rsync", "-av", "--delete"]
+class RsyncUnknownStatus(Exception):
+    def __init__(self, status):
+        Exception.__init__(self, "Unknown status: %d" % status)
+
+class NoRsync(Exception):
+    def __init__(self, rsync_name):
+        Exception.__init__(self, "%s not found." % rsync_name)
+
+def rsync(source, target, ssh=False, excludes=(), silent=False, 
+          rsync_name="rsync"):
+    """
+    >>> rsync("a", "b", silent=True)
+    Traceback (most recent call last):
+    RsyncNoFile: No such file a
+    >>> rsync("a", "b", excludes=("*.py",), silent=True)
+    Traceback (most recent call last):
+    RsyncNoFile: No such file a
+    >>> rsync("a", "b", excludes=("*.py",), silent=True, rsync_name="rsyncc")
+    Traceback (most recent call last):
+    NoRsync: rsyncc not found.
+    """
+    cmd = [rsync_name, "-av", "--delete"]
     if ssh:
         cmd.extend(('-e', 'ssh'))
     if len(excludes) > 0:
         cmd.extend(('--exclude-from', '-'))
     cmd.extend((source, target))
-    proc = Popen(cmd, stdin=PIPE)
+    if silent:
+        stderr = PIPE
+        stdout = PIPE
+    else:
+        stderr = None
+        stdout = None
+    try:
+        proc = Popen(cmd, stdin=PIPE, stderr=stderr, stdout=stdout)
+    except OSError, e:
+        if e.errno == errno.ENOENT:
+            raise NoRsync(rsync_name)
+            
     proc.stdin.write('\n'.join(excludes)+'\n')
     proc.stdin.close()
+    if silent:
+        proc.stderr.read()
+        proc.stderr.close()
+        proc.stdout.read()
+        proc.stdout.close()
     proc.wait()
+    if proc.returncode == 12:
+        raise RsyncStreamIO()
+    elif proc.returncode == 23:
+        raise RsyncNoFile(source)
+    elif proc.returncode != 0:
+        raise RsyncUnknownStatus(proc.returncode)
     return cmd
 
-exclusions = ('.bzr/x-push-data', '.bzr/x-pull-data', '.bzr/stat-cache')
-
-
-def push(cur_branch, location=None):
+
+def rsync_ls(source, ssh=False, silent=True):
+    cmd = ["rsync"]
+    if ssh:
+        cmd.extend(('-e', 'ssh'))
+    cmd.append(source)
+    if silent:
+        stderr = PIPE
+    else:
+        stderr = None
+    proc = Popen(cmd, stderr=stderr, stdout=PIPE)
+    result = proc.stdout.read()
+    proc.stdout.close()
+    if silent:
+        proc.stderr.read()
+        proc.stderr.close()
+    proc.wait()
+    if proc.returncode == 12:
+        raise RsyncStreamIO()
+    elif proc.returncode == 23:
+        raise RsyncNoFile(source)
+    elif proc.returncode != 0:
+        raise RsyncUnknownStatus(proc.returncode)
+    return [l.split(' ')[-1].rstrip('\n') for l in result.splitlines(True)]
+
+exclusions = ('.bzr/x-push-data', '.bzr/parent', '.bzr/x-pull-data', 
+              '.bzr/x-pull', '.bzr/pull', '.bzr/stat-cache',
+              '.bzr/x-rsync-data')
+
+
+def read_revision_history(fname):
+    return [l.rstrip('\r\n') for l in
+            codecs.open(fname, 'rb', 'utf-8').readlines()]
+
+class RsyncNoFile(Exception):
+    def __init__(self, path):
+        Exception.__init__(self, "No such file %s" % path)
+
+class RsyncStreamIO(Exception):
+    def __init__(self):
+        Exception.__init__(self, "Error in rsync protocol data stream.")
+
+def get_revision_history(location):
+    tempdir = tempfile.mkdtemp('push')
+    try:
+        history_fname = os.path.join(tempdir, 'revision-history')
+        cmd = rsync(location+'.bzr/revision-history', history_fname,
+                    silent=True)
+        history = read_revision_history(history_fname)
+    finally:
+        shutil.rmtree(tempdir)
+    return history
+
+def history_subset(location, branch):
+    remote_history = get_revision_history(location)
+    local_history = branch.revision_history()
+    if len(remote_history) > len(local_history):
+        return False
+    for local, remote in zip(remote_history, local_history):
+        if local != remote:
+            return False 
+    return True
+
+def empty_or_absent(location):
+    try:
+        files = rsync_ls(location)
+        return files == ['.']
+    except RsyncNoFile:
+        return True
+
+def push(cur_branch, location=None, overwrite=False):
     push_location = get_push_data(cur_branch)
     if location is not None:
         if not location.endswith('/'):
@@ -165,7 +264,21 @@
 Use "bzr status" to list them."""
         sys.exit(1)
     non_source.extend(exclusions)
-
+    if not overwrite:
+        try:
+            if not history_subset(push_location, cur_branch):
+                raise bzrlib.errors.BzrCommandError("Local branch is not a"
+                                                    " newer version of remote"
+                                                    " branch.")
+        except RsyncNoFile:
+            if not empty_or_absent(push_location):
+                raise bzrlib.errors.BzrCommandError("Remote location is not a"
+                                                    " bzr branch (or empty"
+                                                    " directory)")
+        except RsyncStreamIO:
+            raise bzrlib.errors.BzrCommandError("Rsync could not use the"
+                " specified location.  Please ensure that"
+                ' "%s" is of the form "machine:/path".' % push_location)
     print "Pushing to %s" % push_location
     rsync(cur_branch.base+'/', push_location, ssh=True, excludes=non_source)
 

=== modified file 'clean_tree.py'
--- clean_tree.py	2005-09-09 23:45:23 +0000
+++ clean_tree.py	2005-10-24 00:13:55 +0000
@@ -15,30 +15,90 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 import errno
 import os
+from bzrlib.osutils import has_symlinks, isdir
 import shutil
 from bzrlib.branch import Branch
-
-def clean_tree(unknowns=True, ignored=False):
-    def deletables(tree):
-        for subp in tree.extras():
-            if tree.is_ignored(subp):
-                if not ignored:
-                    continue
-            else:
-                if not unknowns:
-                    continue
+import sys
+
+def is_detrius(subp):
+    return subp.endswith('.THIS') or subp.endswith('.BASE') or\
+        subp.endswith('.OTHER') or subp.endswith('~') or subp.endswith('.tmp')
+
+def iter_deletables(tree, unknown=True, ignored=False, detrius=False):
+    """Iterate through files that may be deleted"""
+    for subp in tree.extras():
+        if detrius and is_detrius(subp):
             yield tree.abspath(subp), subp
-    br = Branch('.')
+            continue
+        if tree.is_ignored(subp):
+            if ignored:
+                yield tree.abspath(subp), subp
+        else:
+            if unknown:
+                yield tree.abspath(subp), subp
+
+def clean_tree(directory, ignored=False, detrius=False, dry_run=False,
+               to_file=sys.stdout):
+    br = Branch.open_containing(directory)[0]
     tree = br.working_tree()
-    printed_once = False
-    for path, subp in deletables(tree):
-        if not printed_once:
-            print "deleting paths:"
-            printed_once = True
-        print ' ', subp
-        try:
-            os.unlink(path)
-        except OSError, e:
-            if e.errno != errno.EISDIR:
-                raise
-            shutil.rmtree(path)
+    deletables = iter_deletables(tree, ignored=ignored, detrius=detrius)
+    delete_items(deletables, dry_run=dry_run, to_file=to_file)
+
+def delete_items(deletables, dry_run=False, to_file=sys.stdout):
+    """Delete files in the deletables iterable"""
+    has_deleted = False
+    for path, subp in deletables:
+        if not has_deleted:
+            print >> to_file, "deleting paths:"
+            has_deleted = True
+        print >> to_file, ' ', subp
+        if not dry_run:
+            if isdir(path):
+                shutil.rmtree(path)
+            else:
+                os.unlink(path)
+    if not has_deleted:
+        print >> to_file, "No files deleted."
+def test_suite():
+    from bzrlib.selftest import TestCaseInTempDir
+    from unittest import makeSuite
+    import os.path
+    from StringIO import StringIO
+    class TestCleanTree(TestCaseInTempDir):
+        def test_symlinks(self):
+            if has_symlinks() is False:
+                return
+            os.mkdir('branch')
+            b = Branch.initialize('branch')
+            os.symlink(os.path.realpath('no-die-please'), 'branch/die-please')
+            os.mkdir('no-die-please')
+            assert os.path.exists('branch/die-please')
+            os.mkdir('no-die-please/child')
+
+            clean_tree('branch', to_file=StringIO())
+            assert os.path.exists('no-die-please')
+            assert os.path.exists('no-die-please/child')
+
+        def test_iter_deletable(self):
+            """Files are selected for deletion appropriately"""
+            os.mkdir('branch')
+            b = Branch.initialize('branch')
+            tree = b.working_tree()
+            file('branch/file.BASE', 'wb').write('contents')
+            self.assertEqual(len(list(iter_deletables(tree))), 1)
+            file('branch/file~', 'wb').write('contents')
+            file('branch/file.pyc', 'wb').write('contents')
+            dels = [r for a,r in iter_deletables(tree)]
+            assert 'file~' not in dels
+            assert 'file.pyc' not in dels
+            dels = [r for a,r in iter_deletables(tree, detrius=True)]
+            assert 'file~' in dels
+            assert 'file.pyc' not in dels
+            dels = [r for a,r in iter_deletables(tree, ignored=True)]
+            assert 'file~' in dels
+            assert 'file.BASE' in dels
+            assert 'file.pyc' in dels
+            dels = [r for a,r in iter_deletables(tree, unknown=False)]
+            assert 'file.BASE' not in dels
+
+    return makeSuite(TestCleanTree)

=== removed file 'conflicts.py'
--- conflicts.py	2005-08-27 05:06:27 +0000
+++ conflicts.py	1970-01-01 00:00:00 +0000
@@ -1,77 +0,0 @@
-# Copyright (C) 2005 by Aaron Bentley
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import bzrlib.status
-from bzrlib.branch import Branch
-import os
-import errno
-
-SUFFIXES = ('.THIS', '.BASE', '.OTHER')
-def get_conflicted_stem(path):
-    for suffix in SUFFIXES:
-        if path.endswith(suffix):
-            return path[:-len(suffix)]
-
-def iter_conflicts(tree):
-    conflicted = set()
-    for path in (s[0] for s in tree.list_files()):
-        stem = get_conflicted_stem(path)
-        if stem is None:
-            continue
-        if stem not in conflicted:
-            conflicted.add(stem)
-            yield stem
-
-class cmd_conflicts(bzrlib.commands.Command):
-    """List files with conflicts.
-    (conflicts are determined by the presence of .BASE .TREE, and .OTHER 
-    files.)
-    """
-    def run(self):
-        for path in iter_conflicts(Branch('.').working_tree()):
-            print path
-
-class cmd_resolve(bzrlib.commands.Command):
-    """Mark a conflict as resolved.
-    """
-    takes_args = ['file+']
-    def run(self, file_list):
-        for file in file_list:
-            failures = 0
-            for suffix in SUFFIXES:
-                try:
-                    os.unlink(file+suffix)
-                except OSError, e:
-                    if e.errno != errno.ENOENT:
-                        raise
-                    else:
-                        failures += 1
-            if failures == len(SUFFIXES):
-                print "%s is not conflicted" % file
-                        
-            
-
-# monkey-patch the standard 'status' to give us conflicts, too.
-def _show_status(branch, **kwargs):
-    old_show_status(branch, **kwargs)
-    conflicted = list(iter_conflicts(branch.working_tree()))
-    if len(conflicted) > 0:
-        print "conflicts:"
-        for f in conflicted:
-            print " ", f
-
-old_show_status = bzrlib.status.show_status
-bzrlib.status.show_status = _show_status 

=== added file 'diffstat.py'
--- diffstat.py	1970-01-01 00:00:00 +0000
+++ diffstat.py	2005-10-25 14:00:28 +0000
@@ -0,0 +1,87 @@
+#!/usr/bin/python
+
+class DiffStat(object):
+    def __init__(self, lines):
+        self.maxname = 0
+        self.maxtotal = 0
+        self.total_adds = 0
+        self.total_removes = 0
+        self.stats = {}
+        self.__parse(lines)
+
+    def __parse(self, lines):
+        import string
+        adds = 0
+        removes = 0
+        current = None
+
+        for line in lines:
+            if line.startswith('+') and not line.startswith('+++'):
+                adds += 1
+            elif line.startswith('-') and not line.startswith('---'):
+                removes += 1
+            elif line.startswith('=== '):
+                self.__add_stats(current, adds, removes)
+
+                adds = 0
+                removes = 0
+                context = 0
+                current = None
+            elif line.startswith('--- ') and current is None:
+                current = line[4:].strip()
+
+        self.__add_stats(current, adds, removes)
+
+    class Filestat:
+        def __init__(self):
+            self.adds = 0
+            self.removes = 0
+            self.total = 0
+
+    def __add_stats(self, file, adds, removes):
+        if file is None:
+            return
+        elif file in self.stats:
+            fstat = self.stats[file]
+        else:
+            fstat = self.Filestat()
+
+        fstat.adds += adds
+        fstat.removes += removes
+        fstat.total = adds + removes
+        self.stats[file] = fstat
+
+        self.maxname = max(self.maxname, len(file))
+        self.maxtotal = max(self.maxtotal, fstat.total)
+        self.total_adds += adds
+        self.total_removes += removes
+
+    def __str__(self):
+        # Work out widths
+        width = 78 - 5
+        countwidth = len(str(self.maxtotal))
+        graphwidth = width - countwidth - self.maxname
+        factor = 1
+
+        while (self.maxtotal / factor) > graphwidth:
+            factor += 1
+
+        s = ""
+
+        for file, fstat in self.stats.iteritems():
+            s += ' %-*s | %*.d ' % (self.maxname, file, countwidth, fstat.total)
+
+            # If diffstat runs out of room it doesn't print anything, which
+            # isn't very useful, so always print at least one + or 1
+            s += '+' * max(fstat.adds / factor, 1)
+            s += '-' * max(fstat.removes / factor, 1)
+            s += '\n'
+
+        s += ' %d files changes, %d insertions(+), %d deletions(-)' % \
+                (len(self.stats), self.total_adds, self.total_removes)
+        return s
+
+if __name__ == '__main__':
+    import sys
+    ds = DiffStat(sys.stdin.readlines())
+    print ds

=== modified file 'dotgraph.py'
--- dotgraph.py	2005-09-01 17:03:54 +0000
+++ dotgraph.py	2005-10-29 18:40:48 +0000
@@ -1,4 +1,20 @@
-#!/usr/bin/env python2.4
+# Copyright (C) 2004, 2005 Aaron Bentley
+# <aaron.bentley@utoronto.ca>
+#
+#    This program is free software; you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation; either version 2 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program; if not, write to the Free Software
+#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
 from subprocess import Popen, PIPE
 from urllib import urlencode
 from xml.sax.saxutils import escape
@@ -6,8 +22,11 @@
 import errno
 import tempfile
 import shutil
+import time
 
-mail_map = {}
+RSVG_OUTPUT_TYPES = ('png', 'jpg')
+DOT_OUTPUT_TYPES = ('svg', 'svgz', 'gif', 'jpg', 'ps', 'fig', 'mif', 'png', 
+                    'cmapx')
 
 class NoDot(Exception):
     def __init__(self):
@@ -19,41 +38,19 @@
 
 class Node(object):
     def __init__(self, name, color=None, label=None, rev_id=None,
-                 cluster=None):
+                 cluster=None, node_style=None, date=None, message=None):
         self.name = name
         self.color = color
         self.label = label
         self.committer = None
         self.rev_id = rev_id
-        self.node_style = []
+        if node_style is None:
+            self.node_style = []
         self.cluster = cluster
-
-    def get_committer(self):
-        if self.committer is not None:
-            if '@' in self.committer:
-                try:
-                    return mail_map[self.committer]
-                except KeyError:
-                    pass
-            return self.committer
-        elif self.rev_id is not None:
-            try:
-                first_segment = '-'.join(self.rev_id.split('-')[:-2])\
-                    .strip(' ')
-            except ValueError:
-                first_segment = []
-            if '@' in first_segment:
-                try:
-                    return mail_map[first_segment]
-                except KeyError:
-                    return first_segment
-
-    def get_label(self):
-        label = None
-        committer = self.get_committer()
-        if committer is not None:
-            label = "%s\\n%s" % (self.name, committer)
-        return label
+        self.rank = None
+        self.date = date
+        self.message = message
+        self.href = None
 
     def define(self):
         attributes = []
@@ -64,54 +61,122 @@
         style.extend(self.node_style)
         if len(style) > 0:
             attributes.append('style="%s"' % ",".join(style))
-        label = self.get_label()
+        label = self.label
         if label is not None:
             attributes.append('label="%s"' % label)
         attributes.append('shape="box"')
+        tooltip = ''
+        if self.message is not None:
+            tooltip += self.message.replace('"', '\\"')
+        if tooltip:
+            attributes.append('tooltip="%s"' % tooltip)
+        if self.href is not None:
+            attributes.append('href="%s"' % self.href)
+        elif tooltip:
+            attributes.append('href="#"')
         if len(attributes) > 0:
             return '%s[%s]' % (self.name, " ".join(attributes))
 
     def __str__(self):
         return self.name
 
-def dot_output(relations):
-    defined = set()
+class Edge(object):
+    def __init__(self, start, end, label=None):
+        object.__init__(self)
+        self.start = start
+        self.end = end
+        self.label = label
+
+    def dot(self, do_weight=False):
+        attributes = []
+        if self.label is not None:
+            attributes.append(('label', self.label))
+        if do_weight:
+            weight = '0'
+            if self.start.cluster == self.end.cluster:
+                weight = '1'
+            elif self.start.rank is None:
+                weight = '1'
+            elif self.end.rank is None:
+                weight = '1'
+            attributes.append(('weight', weight))
+        if len(attributes) > 0:
+            atlist = []
+            for key, value in attributes:
+                atlist.append("%s=\"%s\"" % (key, value))
+            pq = ' '.join(atlist)
+            op = "[%s]" % pq
+        else:
+            op = ""
+        return "%s->%s%s;" % (self.start.name, self.end.name, op)
+
+def make_edge(relation):
+    if hasattr(relation, 'start') and hasattr(relation, 'end'):
+        return relation
+    return Edge(relation[0], relation[1])
+
+def dot_output(relations, ranking="forced"):
+    defined = {}
     yield "digraph G\n"
     yield "{\n"
     clusters = set()
+    edges = [make_edge(f) for f in relations]
     def rel_appropriate(start, end, cluster):
         if cluster is None:
-            return start.cluster is None or end.cluster is None
+            return (start.cluster is None and end.cluster is None) or \
+                start.cluster != end.cluster
         else:
             return start.cluster==cluster and end.cluster==cluster
 
-    for (start, end) in relations:
-        if start.cluster is not None:
-            clusters.add(start.cluster)
-        if end.cluster is not None:
-            clusters.add(end.cluster)
+    for edge in edges:
+        if edge.start.cluster is not None:
+            clusters.add(edge.start.cluster)
+        if edge.end.cluster is not None:
+            clusters.add(edge.end.cluster)
     clusters = list(clusters)
     clusters.append(None)
     for index, cluster in enumerate(clusters):
-        if cluster is not None:
+        if cluster is not None and ranking == "cluster":
             yield "subgraph cluster_%s\n" % index
             yield "{\n"
             yield '    label="%s"\n' % cluster
-        for (start, end) in relations:
-            if start.name not in defined and start.cluster == cluster:
-                defined.add(start.name)
-                my_def = start.define()
-                if my_def is not None:
-                    yield "    %s;\n" % my_def
-            if end.name not in defined and end.cluster == cluster:
-                defined.add(end.name)
-                my_def = end.define()
-                if my_def is not None:
-                    yield "    %s;\n" % my_def
-            if rel_appropriate(start, end, cluster):
-                yield "    %s->%s;\n" % (start.name, end.name)
-        if cluster is not None:
+        for edge in edges:
+            if edge.start.name not in defined and edge.start.cluster == cluster:
+                defined[edge.start.name] = edge.start
+                my_def = edge.start.define()
+                if my_def is not None:
+                    yield "    %s\n" % my_def
+            if edge.end.name not in defined and edge.end.cluster == cluster:
+                defined[edge.end.name] = edge.end
+                my_def = edge.end.define()
+                if my_def is not None:
+                    yield "    %s;\n" % my_def
+            if rel_appropriate(edge.start, edge.end, cluster):
+                yield "    %s\n" % edge.dot(do_weight=ranking=="forced")
+        if cluster is not None and ranking == "cluster":
             yield "}\n"
+
+    if ranking == "forced":
+        ranks = {}
+        for node in defined.itervalues():
+            if node.rank not in ranks:
+                ranks[node.rank] = set()
+            ranks[node.rank].add(node.name)
+        sorted_ranks = [n for n in ranks.iteritems()]
+        sorted_ranks.sort()
+        last_rank = None
+        for rank, nodes in sorted_ranks:
+            if rank is None:
+                continue
+            yield 'rank%d[style="invis"];\n' % rank
+            if last_rank is not None:
+                yield 'rank%d -> rank%d[style="invis"];\n' % (last_rank, rank)
+            last_rank = rank
+        for rank, nodes in ranks.iteritems():
+            if rank is None:
+                continue
+            node_text = "; ".join('"%s"' % n for n in nodes)
+            yield ' {rank = same; "rank%d"; %s}\n' % (rank, node_text)
     yield "}\n"
 
 def invoke_dot_aa(input, out_file, file_type='png'):
@@ -133,8 +198,11 @@
         shutil.rmtree(tempdir)
     return status
 
-def invoke_dot(input, out_file=None, file_type='svg', antialias=None):
-    cmdline = ['dot', '-T%s' % file_type]
+def invoke_dot(input, out_file=None, file_type='svg', antialias=None, 
+               fontname="Helvetica", fontsize=11):
+    cmdline = ['dot', '-T%s' % file_type, '-Nfontname=%s' % fontname, 
+               '-Efontname=%s' % fontname, '-Nfontsize=%d' % fontsize,
+               '-Efontsize=%d' % fontsize]
     if out_file is not None:
         cmdline.extend(('-o', out_file))
     try:
@@ -148,3 +216,34 @@
         dot_proc.stdin.write(line)
     dot_proc.stdin.close()
     return dot_proc.wait()
+
+def invoke_dot_html(input, out_file):
+    """\
+    Produce an html file, which uses a .png file, and a cmap to provide
+    annotated revisions.
+    """
+    tempdir = tempfile.mkdtemp()
+    try:
+        temp_dot = os.path.join(tempdir, 'temp.dot')
+        status = invoke_dot(input, temp_dot, file_type='dot')
+
+        dot = open(temp_dot)
+        temp_file = os.path.join(tempdir, 'temp.cmapx')
+        status = invoke_dot(dot, temp_file, 'cmapx')
+
+        png_file = '.'.join(out_file.split('.')[:-1] + ['png'])
+        dot.seek(0)
+        status = invoke_dot(dot, png_file, 'png')
+
+        png_relative = png_file.split('/')[-1]
+        html = open(out_file, 'wb')
+        w = html.write
+        w('<html><head><title></title></head>\n')
+        w('<body>\n')
+        w('<img src="%s" usemap="#G" border=0/>' % png_relative)
+        w(open(temp_file).read())
+        w('</body></html>\n')
+    finally:
+        shutil.rmtree(tempdir)
+    return status
+

=== modified file 'errors.py'
--- errors.py	2005-08-09 13:12:05 +0000
+++ errors.py	2005-10-29 18:40:48 +0000
@@ -1,3 +1,19 @@
+# Copyright (C) 2005 Aaron Bentley
+# <aaron.bentley@utoronto.ca>
+#
+#    This program is free software; you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation; either version 2 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program; if not, write to the Free Software
+#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 class NoPyBaz(Exception):
     def __init__(self):
         Exception.__init__(self, "PyBaz is not installed.")

=== renamed file 'fetch_missing.py' => 'fetch_ghosts.py'
--- fetch_missing.py	2005-09-09 23:54:33 +0000
+++ fetch_ghosts.py	2005-10-18 20:17:59 +0000
@@ -13,31 +13,28 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-from bzrlib.branch import find_branch
+from bzrlib.branch import Branch
 from bzrlib.fetch import greedy_fetch
-from bzrlib.errors import NoSuchRevision, InstallFailed
-def fetch_missing(branch):
-    """Install the revisions of missing ancestors from another branch."""
-    this_branch = find_branch('.')
+from bzrlib.errors import NoSuchRevision, InstallFailed, BzrCommandError
+def fetch_ghosts(branch):
+    """Install ghosts from copies in another branch."""
+    this_branch = Branch.open_containing('.')[0]
     if branch is None:
-        try:
-            branch = this_branch.controlfile("x-pull", "rb").read().rstrip('\n')
-            print "Using last location: %s" % branch
-        except IOError, e:
-            if e.errno != errno.ENOENT:
-                raise
-            else:
-                raise BzrCommandError("No pull location known or specified.")
+        branch = this_branch.get_parent()
+        if branch is None:
+            raise BzrCommandError('No branch specified and no location saved.')
+        else:
+            print "Using saved location %s" % branch
 
-    other_branch = find_branch(branch)
+    other_branch = Branch.open_containing(branch)[0]
     installed = []
     failed = []
 
-    # Because iter_missing_ancestors tests for existence after our last fetch
-    # is complete, it won't falsely report an ancestor as missing.
+    # Because iter_ghosts tests for existence after our last fetch
+    # is complete, it won't falsely report an ancestor as a ghost.
     # Yay iterators!
-    missing = iter_missing_ancestors(this_branch)
-    for revision in missing:
+    ghosts = iter_ghosts(this_branch)
+    for revision in ghosts:
         try:
             greedy_fetch(this_branch, other_branch, revision)
             installed.append(revision)
@@ -52,10 +49,10 @@
     for rev in failed:
         print rev
 
-def iter_missing_ancestors(branch):
+def iter_ghosts(branch):
     """Find all ancestors that aren't stored in this branch."""
     seen = set()
-    lines = [branch.last_patch()]
+    lines = [branch.last_revision()]
     while len(lines) > 0:
         new_lines = []
         for line in lines:
@@ -64,7 +61,7 @@
             seen.add(line)
             try:
                 revision = branch.get_revision(line)
-                new_lines.extend([r.revision_id for r in revision.parents])
+                new_lines.extend(revision.parent_ids)
             except NoSuchRevision:
                 yield line
         lines = new_lines

=== modified file 'graph.py'
--- graph.py	2005-09-12 18:29:12 +0000
+++ graph.py	2005-10-30 03:51:19 +0000
@@ -1,35 +1,41 @@
+# Copyright (C) 2005 Aaron Bentley
+# <aaron.bentley@utoronto.ca>
+#
+#    This program is free software; you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation; either version 2 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program; if not, write to the Free Software
+#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 from dotgraph import Node, dot_output, invoke_dot, invoke_dot_aa, NoDot, NoRsvg
-from dotgraph import mail_map
+from dotgraph import RSVG_OUTPUT_TYPES, DOT_OUTPUT_TYPES, Edge, invoke_dot_html
 from bzrlib.branch import Branch
-from bzrlib.errors import BzrCommandError
+from bzrlib.errors import BzrCommandError, NoCommonRoot, NoSuchRevision
+from bzrlib.fetch import greedy_fetch
+from bzrlib.graph import node_distances, select_farthest
+from bzrlib.revision import combined_graph, revision_graph
+from bzrlib.revision import MultipleRevisionSources
 import bzrlib.errors
 import re
 import os.path
-
-mail_map.update({'aaron.bentley@utoronto.ca'     : 'Aaron Bentley',
-                 'abentley@panoramicfeedback.com': 'Aaron Bentley',
-                 'abentley@lappy'                : 'Aaron Bentley',
-                 'john@arbash-meinel.com'        : 'John Arbash Meinel',
-                 'mbp@sourcefrog.net'            : 'Martin Pool',
-                 'robertc@robertcollins.net'     : 'Robert Collins',
-                })
-
-def add_relations(rev_id):
-    if rev_id in ancestors:
-        return
-    print rev_id
-    if rev_id not in nodes:
-        nodes[rev_id] = Node("n%d" % counter, label = rev_id)
-        counter += 1
-    revision = branch.get_revision(rev_id)
-    ancestors [rev_id] = []
-    for p in (p.revision_id for p in revision.parents):
-        add_relations(p)
-        if p not in descendants:
-            descendants[p] = []
-        descendants[p].append(rev_id)
-        ancestors [rev_id].append(rev_id)
-
+import time
+
+mail_map = {'aaron.bentley@utoronto.ca'     : 'Aaron Bentley',
+            'abentley@panoramicfeedback.com': 'Aaron Bentley',
+            'abentley@lappy'                : 'Aaron Bentley',
+            'john@arbash-meinel.com'        : 'John Arbash Meinel',
+            'mbp@sourcefrog.net'            : 'Martin Pool',
+            'robertc@robertcollins.net'     : 'Robert Collins',
+            }
+
+committer_alias = {'abentley': 'Aaron Bentley'}
 def short_committer(committer):
     new_committer = re.sub('<.*>', '', committer).strip(' ')
     if len(new_committer) < 2:
@@ -39,105 +45,245 @@
 def can_skip(rev_id, descendants, ancestors):
     if rev_id not in descendants:
         return False
+    elif rev_id not in ancestors:
+        return False
     elif len(ancestors[rev_id]) != 1:
         return False
-    elif len(descendants[ancestors[rev_id][0]]) != 1:
+    elif len(descendants[list(ancestors[rev_id])[0]]) != 1:
         return False
     elif len(descendants[rev_id]) != 1:
         return False
     else:
         return True
 
-def compact_descendants(descendants, ancestors):
-    new_descendants={}
+def compact_ancestors(descendants, ancestors, exceptions=()):
+    new_ancestors={}
     skip = set()
-    for me, my_descendants in descendants.iteritems():
+    for me, my_parents in ancestors.iteritems():
         if me in skip:
             continue
-        new_descendants[me] = []
-        for descendant in my_descendants:
-            new_descendant = descendant
-            while can_skip(new_descendant, descendants, ancestors):
-                skip.add(new_descendant)
-                if new_descendant in new_descendants:
-                    del new_descendants[new_descendant]
-                new_descendant = descendants[new_descendant][0]
-            new_descendants[me].append(new_descendant)
-    return new_descendants    
-
-
-def graph_ancestry(branch, collapse=True):
-    nodes = {}
-    q = ((i+1, n) for (i, n) in enumerate(branch.revision_history()))
-    r = 1
-    try:
-        branch_name = os.path.basename(branch.base)
-    except AttributeError:
-        branch_name = "main"
-    for (revno, rev_id) in q:
-        nodes[rev_id] = Node("R%d" % revno, color="#ffff00", rev_id=rev_id, 
-                             cluster=branch_name)
-
-    ancestors = {} 
-    descendants = {}
-    counter = 0
-    lines = [branch.last_patch()]
-    while len(lines) > 0:
-        new_lines = set()
-        for rev_id in lines:
-            if rev_id not in nodes:
-                nodes[rev_id] = Node("n%d" % counter, label=rev_id, 
-                                     rev_id=rev_id)
-                counter+=1
-                
+        new_ancestors[me] = {} 
+        for parent in my_parents:
+            new_parent = parent 
+            distance = 0
+            while can_skip(new_parent, descendants, ancestors):
+                if new_parent in exceptions:
+                    break
+                skip.add(new_parent)
+                if new_parent in new_ancestors:
+                    del new_ancestors[new_parent]
+                new_parent = list(ancestors[new_parent])[0]
+                distance += 1
+            new_ancestors[me][new_parent] = distance
+    return new_ancestors    
+
+def get_rev_info(rev_id, source):
+    """Return the committer, message, and date of a revision."""
+    committer = None
+    message = None
+    date = None
+    if rev_id == 'null:':
+        return None, 'Null Revision', None
+    try:
+        rev = source.get_revision(rev_id)
+    except NoSuchRevision:
+        try:
+            committer = '-'.join(rev_id.split('-')[:-2]).strip(' ')
+            if committer == '':
+                return None, None, None
+        except ValueError:
+            return None, None, None
+    else:
+        committer = short_committer(rev.committer)
+        if rev.message is not None:
+            message = rev.message.split('\n')[0]
+        gmtime = time.gmtime(rev.timestamp + (rev.timezone or 0))
+        date = time.strftime('%Y/%m/%d', gmtime)
+    if '@' in committer:
+        try:
+            committer = mail_map[committer]
+        except KeyError:
+            pass
+    try:
+        committer = committer_alias[committer]
+    except KeyError:
+        pass
+    return committer, message, date
+
+class Grapher(object):
+    def __init__(self, branch, other_branch=None):
+        object.__init__(self)
+        self.branch = branch
+        self.other_branch = other_branch
+        revision_a = self.branch.last_revision()
+        if other_branch is not None:
+            greedy_fetch(branch, other_branch)
+            revision_b = self.other_branch.last_revision()
             try:
-                revision = branch.get_revision(rev_id)
-            except bzrlib.errors.NoSuchRevision:
-                nodes[rev_id].node_style.append('dotted')
-                continue
-            if nodes[rev_id].committer is None:
-                nodes[rev_id].committer = short_committer(revision.committer)
-            parent_ids = [r.revision_id for r in revision.parents]
-            ancestors [rev_id] = parent_ids
-            for parent in parent_ids:
-                if parent not in ancestors:
-                    new_lines.add(parent)
-                    descendants[parent] = []
-                descendants[parent].append(rev_id)
-        lines = new_lines
-    node_relations = []
-
-    if collapse:
-        visible_descendants = compact_descendants(descendants, ancestors)
+                self.root, self.ancestors, self.descendants, self.common = \
+                    combined_graph(revision_a, revision_b, self.branch)
+            except bzrlib.errors.NoCommonRoot:
+                raise bzrlib.errors.NoCommonAncestor(revision_a, revision_b)
+        else:
+            self.root, self.ancestors, self.descendants = \
+                revision_graph(revision_a, branch)
+            self.common = []
+
+        self.n_history = branch.revision_history()
+        self.distances = node_distances(self.descendants, self.ancestors, 
+                                        self.root)
+        if other_branch is not None:
+            self.base = select_farthest(self.distances, self.common)
+            self.m_history = other_branch.revision_history() 
+        else:
+            self.base = None
+            self.m_history = []
+
+    def dot_node(self, node, num):
+        try:
+            n_rev = self.n_history.index(node) + 1
+        except ValueError:
+            n_rev = None
+        try:
+            m_rev = self.m_history.index(node) + 1
+        except ValueError:
+            m_rev = None
+        if (n_rev, m_rev) == (None, None):
+            name = node[-5:]
+            cluster = None
+        elif n_rev == m_rev:
+            name = "rR%d" % n_rev
+        else:
+            namelist = []
+            for prefix, revno in (('r', n_rev), ('R', m_rev)):
+                if revno is not None:
+                    namelist.append("%s%d" % (prefix, revno))
+            name = ' '.join(namelist)
+        if None not in (n_rev, m_rev):
+            cluster = "common_history"
+            color = "#ff9900"
+        elif (None, None) == (n_rev, m_rev):
+            cluster = None
+            if node in self.common:
+                color = "#6699ff"
+            else:
+                color = "white"
+        elif n_rev is not None:
+            cluster = "my_history"
+            color = "#ffff00"
+        else:
+            assert m_rev is not None
+            cluster = "other_history"
+            color = "#ff0000"
+        if node == self.base:
+            color = "#33ff99"
+
+        label = [name]
+        committer, message, date = get_rev_info(node, self.branch)
+        if committer is not None:
+            label.append(committer)
+
+        if date is not None:
+            label.append(date)
+
+        if node in self.distances:
+            rank = self.distances[node]
+            label.append('d%d' % self.distances[node])
+        else:
+            rank = None
+
+        d_node = Node("n%d" % num, color=color, label="\\n".join(label), 
+                    rev_id=node, cluster=cluster, message=message,
+                    date=date)
+        d_node.rank = rank
+
+        if node not in self.ancestors:
+            d_node.node_style.append('dotted')
+
+        return d_node
+        
+    def get_relations(self, collapse=False):
+        dot_nodes = {}
+        node_relations = []
+        num = 0
+        if collapse:
+            visible_ancestors = compact_ancestors(self.descendants, 
+                                                  self.ancestors, (self.base,))
+        else:
+            visible_ancestors = self.ancestors
+        for node, parents in visible_ancestors.iteritems():
+            if node not in dot_nodes:
+                dot_nodes[node] = self.dot_node(node, num)
+                num += 1
+            if visible_ancestors is self.ancestors:
+                parent_iter = ((f, 0) for f in parents)
+            else:
+                parent_iter = (f for f in parents.iteritems())
+            for parent, skipped in parent_iter:
+                if parent not in dot_nodes:
+                    dot_nodes[parent] = self.dot_node(parent, num)
+                    num += 1
+                edge = Edge(dot_nodes[parent], dot_nodes[node])
+                if skipped != 0:
+                    edge.label = "%d" % skipped
+                node_relations.append(edge)
+        return node_relations
+
+
+def write_ancestry_file(branch, filename, collapse=True, antialias=True,
+                        merge_branch=None, ranking="forced"):
+    b = Branch.open_containing(branch)[0]
+    if merge_branch is not None:
+        m = Branch.open_containing(merge_branch)[0]
     else:
-        visible_descendants = descendants
-                
-    for key, values in visible_descendants.iteritems():
-        for value in values:
-            node_relations.append((nodes[key], nodes[value]))
-    return node_relations
+        m = None
+    b.lock_read()
+    try:
+        if m is not None:
+            m.lock_read()
+        try:
+            grapher = Grapher(b, m)
+            relations = grapher.get_relations(collapse)
+        finally:
+            if m is not None:
+                m.unlock()
+    finally:
+        b.unlock()
 
-def write_ancestry_file(branch, filename, collapse=True, antialias=True):
-    b = Branch(branch)
-    relations = graph_ancestry(b, collapse)
     ext = filename.split('.')[-1]
-    if antialias and ext in ('png', 'jpg'):
+    output = dot_output(relations, ranking)
+    done = False
+    if ext not in RSVG_OUTPUT_TYPES:
+        antialias = False
+    if antialias: 
+        output = list(output)
         try:
-            invoke_dot_aa(dot_output(relations), filename, ext)
+            invoke_dot_aa(output, filename, ext)
+            done = True
         except NoDot, e:
             raise BzrCommandError("Can't find 'dot'.  Please ensure Graphviz"\
                 " is installed correctly.")
         except NoRsvg, e:
-            raise BzrCommandError("Can't find 'rsvg'.  Please ensure "\
-                "librsvg-bin is installed correctly, or use --noantialias.")
-    elif ext in ('svg', 'svgz', 'gif', 'jpg', 'ps', 'fig', 'mif', 'png'):
-        try:
-            invoke_dot(dot_output(relations), filename, ext)
-        except NoDot, e:
-            raise BzrCommandError("Can't find 'dot'.  Please ensure Graphviz"\
-                " is installed correctly, or use --noantialias")
-    elif ext=='dot':
-        file(filename, 'wb').write("".join(list(dot_output(relations))))
-    else:
+            print "Not antialiasing because rsvg (from librsvg-bin) is not"\
+                " installed."
+            antialias = False
+    if ext in DOT_OUTPUT_TYPES and not antialias and not done:
+        try:
+            invoke_dot(output, filename, ext)
+            done = True
+        except NoDot, e:
+            raise BzrCommandError("Can't find 'dot'.  Please ensure Graphviz"\
+                " is installed correctly, or use --noantialias")
+    elif ext == 'dot' and not done:
+        my_file = file(filename, 'wb')
+        for fragment in output:
+            my_file.write(fragment)
+    elif ext == 'html':
+        try:
+            invoke_dot_html(output, filename)
+        except NoDot, e:
+            raise BzrCommandError("Can't find 'dot'.  Please ensure Graphviz"\
+                " is installed correctly, or use --noantialias")
+    elif not done:
         print "Unknown file extension: %s" % ext
 

=== added file 'hunk_selector.py'
--- hunk_selector.py	1970-01-01 00:00:00 +0000
+++ hunk_selector.py	2005-10-19 10:11:42 +0000
@@ -0,0 +1,196 @@
+#!/usr/bin/python
+
+import sys
+
+class HunkSelector:
+    class Option:
+        def __init__(self, char, action, help, default=False):
+            self.char = char
+            self.action = action
+            self.default = default
+            self.help = help
+
+    standard_options = [
+        Option('n', 'shelve', 'shelve this change for the moment.',
+            default=True),
+        Option('y', 'keep', 'keep this change in your tree.'),
+        Option('d', 'done', 'done, skip to the end.'),
+        Option('i', 'invert', 'invert the current selection of all hunks.'),
+        Option('s', 'status', 'show status of hunks.'),
+        Option('q', 'quit', 'quit')
+    ]
+
+    end_options = [
+        Option('y', 'continue', 'proceed to shelve selected changes.',
+            default=True),
+        Option('r', 'restart', 'restart the hunk selection loop.'),
+        Option('s', 'status', 'show status of hunks.'),
+        Option('i', 'invert', 'invert the current selection of all hunks.'),
+        Option('q', 'quit', 'quit')
+    ]
+
+    def __init__(self, patches):
+        self.patches = patches
+        self.total_hunks = 0
+        for patch in patches:
+            for hunk in patch.hunks:
+                # everything's shelved by default
+                hunk.selected = True
+                self.total_hunks += 1
+
+    def __get_option(self, char):
+        for opt in self.standard_options:
+            if opt.char == char:
+                return opt
+        raise Exception('Option "%s" not found!' % char)
+
+    def __select_loop(self):
+        j = 0
+        for patch in self.patches:
+            i = 0
+            lasti = -1
+            while i < len(patch.hunks):
+                hunk = patch.hunks[i]
+                if lasti != i:
+                    print patch.get_header(), hunk
+                    j += 1
+                lasti = i
+
+                prompt = 'Keep this change? (%d of %d)' \
+                            % (j, self.total_hunks)
+
+                if hunk.selected:
+                    self.__get_option('n').default = True
+                    self.__get_option('y').default = False
+                else:
+                    self.__get_option('n').default = False
+                    self.__get_option('y').default = True
+
+                action = self.__ask_user(prompt, self.standard_options)
+
+                if action == 'keep':
+                    hunk.selected = False
+                elif action == 'shelve':
+                    hunk.selected = True
+                elif action == 'done':
+                    return True
+                elif action == 'invert':
+                    self.__invert_selection()
+                    self.__show_status()
+                    continue
+                elif action == 'status':
+                    self.__show_status()
+                    continue
+                elif action == 'quit':
+                    return False
+
+                i += 1
+        return True
+
+    def select(self):
+        if self.total_hunks == 0:
+            return []
+
+        done = False
+        while not done:
+            if not self.__select_loop():
+                return []
+
+            while True:
+                self.__show_status()
+                prompt = "Shelve these changes, or restart?"
+                action = self.__ask_user(prompt, self.end_options)
+
+                if action == 'continue':
+                    done = True
+                    break
+                elif action == 'quit':
+                    return []
+                elif action == 'status':
+                    self.__show_status()
+                elif action == 'invert':
+                    self.__invert_selection()
+                elif action == 'restart':
+                    break
+
+
+        for patch in self.patches:
+            tmp = []
+            for hunk in patch.hunks:
+                if hunk.selected:
+                    tmp.append(hunk)
+            patch.hunks = tmp
+
+        tmp = []
+        for patch in self.patches:
+            if len(patch.hunks):
+                tmp.append(patch)
+        self.patches = tmp
+
+        return self.patches
+
+    def __invert_selection(self):
+        for patch in self.patches:
+            for hunk in patch.hunks:
+                if hunk.__dict__.has_key('selected'):
+                    hunk.selected = not hunk.selected
+                else:
+                    hunk.selected = True
+
+    def __show_status(self):
+        print '\nStatus:'
+        for patch in self.patches:
+            print '  %s' % patch.oldname
+            shelve = 0
+            keep = 0
+            for hunk in patch.hunks:
+                if hunk.selected:
+                    shelve += 1
+                else:
+                    keep += 1
+
+            print '    %d hunks to be shelved' % shelve
+            print '    %d hunks to be kept' % keep
+            print
+
+    if sys.platform == "win32":
+        import msvcrt
+        def __getchar(self):
+            return msvcrt.getche()
+    else:
+        def __getchar(self):
+            import tty
+            import termios
+            fd = sys.stdin.fileno()
+            settings = termios.tcgetattr(fd)
+            try:
+                tty.setraw(fd)
+                ch = sys.stdin.read(1)
+            finally:
+                termios.tcsetattr(fd, termios.TCSADRAIN, settings)
+            return ch
+
+    def __ask_user(self, prompt, options):
+        while True:
+            sys.stdout.write(prompt)
+            sys.stdout.write(' [')
+            for opt in options:
+                if opt.default:
+                    default = opt
+                sys.stdout.write(opt.char)
+            sys.stdout.write('?] (%s): ' % default.char)
+
+            response = self.__getchar()
+
+            # default, which we see as newline, is 'n'
+            if response in ['\n', '\r', '\r\n']:
+                response = default.char
+
+            print response # because echo is off
+
+            for opt in options:
+                if opt.char == response:
+                    return opt.action
+
+            for opt in options:
+                print '  %s - %s' % (opt.char, opt.help)

=== modified file 'patch.py'
--- patch.py	2005-09-11 03:28:31 +0000
+++ patch.py	2005-10-30 03:51:19 +0000
@@ -1,11 +1,37 @@
+# Copyright (C) 2005 Aaron Bentley
+# <aaron.bentley@utoronto.ca>
+#
+#    This program is free software; you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation; either version 2 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program; if not, write to the Free Software
+#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 import sys
 from subprocess import Popen, PIPE
-def patch(branch, filename, strip):
-    """Apply a patch to a branch, using patch(1)."""
-    if filename is None:
+from bzrlib.transport import get_transport
+from urlparse import urlsplit, urlunsplit
+def patch(branch, location, strip):
+    """Apply a patch to a branch, using patch(1).  URLs may be used."""
+    my_file = None
+    if location is None:
         my_file = sys.stdin
     else:
-        my_file = file(filename, 'rb')
+        for prefix in ('http://', 'sftp://', 'file://'):
+            if not location.startswith(prefix):
+                continue
+            (scheme, loc, path, query, fragment) = urlsplit(location)
+            loc_start = urlunsplit((scheme, loc, '/', '', ''))
+            my_file = get_transport(loc_start).get(path[1:])
+        if my_file is None:
+            my_file = file(location, 'rb')
     cmd = ['patch', '--directory', branch.base, '--strip', str(strip)]
     child_proc = Popen(cmd, stdin=PIPE)
     for line in my_file:

=== added file 'patches.py'
--- patches.py	1970-01-01 00:00:00 +0000
+++ patches.py	2005-10-19 09:34:33 +0000
@@ -0,0 +1,560 @@
+# Copyright (C) 2004, 2005 Aaron Bentley
+# <aaron.bentley@utoronto.ca>
+#
+#    This program is free software; you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation; either version 2 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program; if not, write to the Free Software
+#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+class PatchSyntax(Exception):
+    def __init__(self, msg):
+        Exception.__init__(self, msg)
+
+
+class MalformedPatchHeader(PatchSyntax):
+    def __init__(self, desc, line):
+        self.desc = desc
+        self.line = line
+        msg = "Malformed patch header.  %s\n%r" % (self.desc, self.line)
+        PatchSyntax.__init__(self, msg)
+
+class MalformedHunkHeader(PatchSyntax):
+    def __init__(self, desc, line):
+        self.desc = desc
+        self.line = line
+        msg = "Malformed hunk header.  %s\n%r" % (self.desc, self.line)
+        PatchSyntax.__init__(self, msg)
+
+class MalformedLine(PatchSyntax):
+    def __init__(self, desc, line):
+        self.desc = desc
+        self.line = line
+        msg = "Malformed line.  %s\n%s" % (self.desc, self.line)
+        PatchSyntax.__init__(self, msg)
+
+def get_patch_names(iter_lines):
+    try:
+        line = iter_lines.next()
+        if not line.startswith("--- "):
+            raise MalformedPatchHeader("No orig name", line)
+        else:
+            orig_name = line[4:].rstrip("\n")
+    except StopIteration:
+        raise MalformedPatchHeader("No orig line", "")
+    try:
+        line = iter_lines.next()
+        if not line.startswith("+++ "):
+            raise PatchSyntax("No mod name")
+        else:
+            mod_name = line[4:].rstrip("\n")
+    except StopIteration:
+        raise MalformedPatchHeader("No mod line", "")
+    return (orig_name, mod_name)
+
+def parse_range(textrange):
+    """Parse a patch range, handling the "1" special-case
+
+    :param textrange: The text to parse
+    :type textrange: str
+    :return: the position and range, as a tuple
+    :rtype: (int, int)
+    """
+    tmp = textrange.split(',')
+    if len(tmp) == 1:
+        pos = tmp[0]
+        range = "1"
+    else:
+        (pos, range) = tmp
+    pos = int(pos)
+    range = int(range)
+    return (pos, range)
+
+ 
+def hunk_from_header(line):
+    if not line.startswith("@@") or not line.endswith("@@\n") \
+        or not len(line) > 4:
+        raise MalformedHunkHeader("Does not start and end with @@.", line)
+    try:
+        (orig, mod) = line[3:-4].split(" ")
+    except Exception, e:
+        raise MalformedHunkHeader(str(e), line)
+    if not orig.startswith('-') or not mod.startswith('+'):
+        raise MalformedHunkHeader("Positions don't start with + or -.", line)
+    try:
+        (orig_pos, orig_range) = parse_range(orig[1:])
+        (mod_pos, mod_range) = parse_range(mod[1:])
+    except Exception, e:
+        raise MalformedHunkHeader(str(e), line)
+    if mod_range < 0 or orig_range < 0:
+        raise MalformedHunkHeader("Hunk range is negative", line)
+    return Hunk(orig_pos, orig_range, mod_pos, mod_range)
+
+
+class HunkLine:
+    def __init__(self, contents):
+        self.contents = contents
+
+    def get_str(self, leadchar):
+        if self.contents == "\n" and leadchar == " " and False:
+            return "\n"
+        if not self.contents.endswith('\n'):
+            terminator = '\n' + NO_NL
+        else:
+            terminator = ''
+        return leadchar + self.contents + terminator
+
+
+class ContextLine(HunkLine):
+    def __init__(self, contents):
+        HunkLine.__init__(self, contents)
+
+    def __str__(self):
+        return self.get_str(" ")
+
+
+class InsertLine(HunkLine):
+    def __init__(self, contents):
+        HunkLine.__init__(self, contents)
+
+    def __str__(self):
+        return self.get_str("+")
+
+
+class RemoveLine(HunkLine):
+    def __init__(self, contents):
+        HunkLine.__init__(self, contents)
+
+    def __str__(self):
+        return self.get_str("-")
+
+NO_NL = '\\ No newline at end of file\n'
+__pychecker__="no-returnvalues"
+
+def parse_line(line):
+    if line.startswith("\n"):
+        return ContextLine(line)
+    elif line.startswith(" "):
+        return ContextLine(line[1:])
+    elif line.startswith("+"):
+        return InsertLine(line[1:])
+    elif line.startswith("-"):
+        return RemoveLine(line[1:])
+    elif line == NO_NL:
+        return NO_NL
+    else:
+        raise MalformedLine("Unknown line type", line)
+__pychecker__=""
+
+
+class Hunk:
+    def __init__(self, orig_pos, orig_range, mod_pos, mod_range):
+        self.orig_pos = orig_pos
+        self.orig_range = orig_range
+        self.mod_pos = mod_pos
+        self.mod_range = mod_range
+        self.lines = []
+
+    def get_header(self):
+        return "@@ -%s +%s @@\n" % (self.range_str(self.orig_pos, 
+                                                   self.orig_range),
+                                    self.range_str(self.mod_pos, 
+                                                   self.mod_range))
+
+    def range_str(self, pos, range):
+        """Return a file range, special-casing for 1-line files.
+
+        :param pos: The position in the file
+        :type pos: int
+        :range: The range in the file
+        :type range: int
+        :return: a string in the format 1,4 except when range == pos == 1
+        """
+        if range == 1:
+            return "%i" % pos
+        else:
+            return "%i,%i" % (pos, range)
+
+    def __str__(self):
+        lines = [self.get_header()]
+        for line in self.lines:
+            lines.append(str(line))
+        return "".join(lines)
+
+    def shift_to_mod(self, pos):
+        if pos < self.orig_pos-1:
+            return 0
+        elif pos > self.orig_pos+self.orig_range:
+            return self.mod_range - self.orig_range
+        else:
+            return self.shift_to_mod_lines(pos)
+
+    def shift_to_mod_lines(self, pos):
+        assert (pos >= self.orig_pos-1 and pos <= self.orig_pos+self.orig_range)
+        position = self.orig_pos-1
+        shift = 0
+        for line in self.lines:
+            if isinstance(line, InsertLine):
+                shift += 1
+            elif isinstance(line, RemoveLine):
+                if position == pos:
+                    return None
+                shift -= 1
+                position += 1
+            elif isinstance(line, ContextLine):
+                position += 1
+            if position > pos:
+                break
+        return shift
+
+def iter_hunks(iter_lines):
+    hunk = None
+    for line in iter_lines:
+        if line == "\n":
+            if hunk is not None:
+                yield hunk
+                hunk = None
+            continue
+        if hunk is not None:
+            yield hunk
+        hunk = hunk_from_header(line)
+        orig_size = 0
+        mod_size = 0
+        while orig_size < hunk.orig_range or mod_size < hunk.mod_range:
+            hunk_line = parse_line(iter_lines.next())
+            hunk.lines.append(hunk_line)
+            if isinstance(hunk_line, (RemoveLine, ContextLine)):
+                orig_size += 1
+            if isinstance(hunk_line, (InsertLine, ContextLine)):
+                mod_size += 1
+    if hunk is not None:
+        yield hunk
+
+class Patch:
+    def __init__(self, oldname, newname):
+        self.oldname = oldname
+        self.newname = newname
+        self.hunks = []
+
+    def __str__(self):
+        ret = self.get_header() 
+        ret += "".join([str(h) for h in self.hunks])
+        return ret
+
+    def get_header(self):
+        return "--- %s\n+++ %s\n" % (self.oldname, self.newname)
+
+    def stats_str(self):
+        """Return a string of patch statistics"""
+        removes = 0
+        inserts = 0
+        for hunk in self.hunks:
+            for line in hunk.lines:
+                if isinstance(line, InsertLine):
+                     inserts+=1;
+                elif isinstance(line, RemoveLine):
+                     removes+=1;
+        return "%i inserts, %i removes in %i hunks" % \
+            (inserts, removes, len(self.hunks))
+
+    def pos_in_mod(self, position):
+        newpos = position
+        for hunk in self.hunks:
+            shift = hunk.shift_to_mod(position)
+            if shift is None:
+                return None
+            newpos += shift
+        return newpos
+            
+    def iter_inserted(self):
+        """Iteraties through inserted lines
+        
+        :return: Pair of line number, line
+        :rtype: iterator of (int, InsertLine)
+        """
+        for hunk in self.hunks:
+            pos = hunk.mod_pos - 1;
+            for line in hunk.lines:
+                if isinstance(line, InsertLine):
+                    yield (pos, line)
+                    pos += 1
+                if isinstance(line, ContextLine):
+                    pos += 1
+
+def parse_patch(iter_lines):
+    (orig_name, mod_name) = get_patch_names(iter_lines)
+    patch = Patch(orig_name, mod_name)
+    for hunk in iter_hunks(iter_lines):
+        patch.hunks.append(hunk)
+    return patch
+
+
+def iter_file_patch(iter_lines):
+    saved_lines = []
+    for line in iter_lines:
+        if line.startswith('*** '):
+            continue
+        if line.startswith('==='):
+            continue
+        elif line.startswith('--- '):
+            if len(saved_lines) > 0:
+                yield saved_lines
+            saved_lines = []
+        saved_lines.append(line)
+    if len(saved_lines) > 0:
+        yield saved_lines
+
+
+def iter_lines_handle_nl(iter_lines):
+    """
+    Iterates through lines, ensuring that lines that originally had no
+    terminating \n are produced without one.  This transformation may be
+    applied at any point up until hunk line parsing, and is safe to apply
+    repeatedly.
+    """
+    last_line = None
+    for line in iter_lines:
+        if line == NO_NL:
+            assert last_line.endswith('\n')
+            last_line = last_line[:-1]
+            line = None
+        if last_line is not None:
+            yield last_line
+        last_line = line
+    if last_line is not None:
+        yield last_line
+
+
+def parse_patches(iter_lines):
+    iter_lines = iter_lines_handle_nl(iter_lines)
+    return [parse_patch(f.__iter__()) for f in iter_file_patch(iter_lines)]
+
+
+def difference_index(atext, btext):
+    """Find the indext of the first character that differs betweeen two texts
+
+    :param atext: The first text
+    :type atext: str
+    :param btext: The second text
+    :type str: str
+    :return: The index, or None if there are no differences within the range
+    :rtype: int or NoneType
+    """
+    length = len(atext)
+    if len(btext) < length:
+        length = len(btext)
+    for i in range(length):
+        if atext[i] != btext[i]:
+            return i;
+    return None
+
+class PatchConflict(Exception):
+    def __init__(self, line_no, orig_line, patch_line):
+        orig = orig_line.rstrip('\n')
+        patch = str(patch_line).rstrip('\n')
+        msg = 'Text contents mismatch at line %d.  Original has "%s",'\
+            ' but patch says it should be "%s"' % (line_no, orig, patch)
+        Exception.__init__(self, msg)
+
+
+def iter_patched(orig_lines, patch_lines):
+    """Iterate through a series of lines with a patch applied.
+    This handles a single file, and does exact, not fuzzy patching.
+    """
+    if orig_lines is not None:
+        orig_lines = orig_lines.__iter__()
+    seen_patch = []
+    patch_lines = iter_lines_handle_nl(patch_lines.__iter__())
+    get_patch_names(patch_lines)
+    line_no = 1
+    for hunk in iter_hunks(patch_lines):
+        while line_no < hunk.orig_pos:
+            orig_line = orig_lines.next()
+            yield orig_line
+            line_no += 1
+        for hunk_line in hunk.lines:
+            seen_patch.append(str(hunk_line))
+            if isinstance(hunk_line, InsertLine):
+                yield hunk_line.contents
+            elif isinstance(hunk_line, (ContextLine, RemoveLine)):
+                orig_line = orig_lines.next()
+                if orig_line != hunk_line.contents:
+                    raise PatchConflict(line_no, orig_line, "".join(seen_patch))
+                if isinstance(hunk_line, ContextLine):
+                    yield orig_line
+                else:
+                    assert isinstance(hunk_line, RemoveLine)
+                line_no += 1
+                    
+import unittest
+import os.path
+class PatchesTester(unittest.TestCase):
+    def datafile(self, filename):
+        data_path = os.path.join(os.path.dirname(__file__), "testdata", 
+                                 filename)
+        return file(data_path, "rb")
+
+    def testValidPatchHeader(self):
+        """Parse a valid patch header"""
+        lines = "--- orig/commands.py\n+++ mod/dommands.py\n".split('\n')
+        (orig, mod) = get_patch_names(lines.__iter__())
+        assert(orig == "orig/commands.py")
+        assert(mod == "mod/dommands.py")
+
+    def testInvalidPatchHeader(self):
+        """Parse an invalid patch header"""
+        lines = "-- orig/commands.py\n+++ mod/dommands.py".split('\n')
+        self.assertRaises(MalformedPatchHeader, get_patch_names,
+                          lines.__iter__())
+
+    def testValidHunkHeader(self):
+        """Parse a valid hunk header"""
+        header = "@@ -34,11 +50,6 @@\n"
+        hunk = hunk_from_header(header);
+        assert (hunk.orig_pos == 34)
+        assert (hunk.orig_range == 11)
+        assert (hunk.mod_pos == 50)
+        assert (hunk.mod_range == 6)
+        assert (str(hunk) == header)
+
+    def testValidHunkHeader2(self):
+        """Parse a tricky, valid hunk header"""
+        header = "@@ -1 +0,0 @@\n"
+        hunk = hunk_from_header(header);
+        assert (hunk.orig_pos == 1)
+        assert (hunk.orig_range == 1)
+        assert (hunk.mod_pos == 0)
+        assert (hunk.mod_range == 0)
+        assert (str(hunk) == header)
+
+    def makeMalformed(self, header):
+        self.assertRaises(MalformedHunkHeader, hunk_from_header, header)
+
+    def testInvalidHeader(self):
+        """Parse an invalid hunk header"""
+        self.makeMalformed(" -34,11 +50,6 \n")
+        self.makeMalformed("@@ +50,6 -34,11 @@\n")
+        self.makeMalformed("@@ -34,11 +50,6 @@")
+        self.makeMalformed("@@ -34.5,11 +50,6 @@\n")
+        self.makeMalformed("@@-34,11 +50,6@@\n")
+        self.makeMalformed("@@ 34,11 50,6 @@\n")
+        self.makeMalformed("@@ -34,11 @@\n")
+        self.makeMalformed("@@ -34,11 +50,6.5 @@\n")
+        self.makeMalformed("@@ -34,11 +50,-6 @@\n")
+
+    def lineThing(self,text, type):
+        line = parse_line(text)
+        assert(isinstance(line, type))
+        assert(str(line)==text)
+
+    def makeMalformedLine(self, text):
+        self.assertRaises(MalformedLine, parse_line, text)
+
+    def testValidLine(self):
+        """Parse a valid hunk line"""
+        self.lineThing(" hello\n", ContextLine)
+        self.lineThing("+hello\n", InsertLine)
+        self.lineThing("-hello\n", RemoveLine)
+    
+    def testMalformedLine(self):
+        """Parse invalid valid hunk lines"""
+        self.makeMalformedLine("hello\n")
+    
+    def compare_parsed(self, patchtext):
+        lines = patchtext.splitlines(True)
+        patch = parse_patch(lines.__iter__())
+        pstr = str(patch)
+        i = difference_index(patchtext, pstr)
+        if i is not None:
+            print "%i: \"%s\" != \"%s\"" % (i, patchtext[i], pstr[i])
+        self.assertEqual (patchtext, str(patch))
+
+    def testAll(self):
+        """Test parsing a whole patch"""
+        patchtext = """--- orig/commands.py
++++ mod/commands.py
+@@ -1337,7 +1337,8 @@
+ 
+     def set_title(self, command=None):
+         try:
+-            version = self.tree.tree_version.nonarch
++            version = pylon.alias_or_version(self.tree.tree_version, self.tree,
++                                             full=False)
+         except:
+             version = "[no version]"
+         if command is None:
+@@ -1983,7 +1984,11 @@
+                                          version)
+         if len(new_merges) > 0:
+             if cmdutil.prompt("Log for merge"):
+-                mergestuff = cmdutil.log_for_merge(tree, comp_version)
++                if cmdutil.prompt("changelog for merge"):
++                    mergestuff = "Patches applied:\\n"
++                    mergestuff += pylon.changelog_for_merge(new_merges)
++                else:
++                    mergestuff = cmdutil.log_for_merge(tree, comp_version)
+                 log.description += mergestuff
+         log.save()
+     try:
+"""
+        self.compare_parsed(patchtext)
+
+    def testInit(self):
+        """Handle patches missing half the position, range tuple"""
+        patchtext = \
+"""--- orig/__init__.py
++++ mod/__init__.py
+@@ -1 +1,2 @@
+ __docformat__ = "restructuredtext en"
++__doc__ = An alternate Arch commandline interface
+"""
+        self.compare_parsed(patchtext)
+        
+
+
+    def testLineLookup(self):
+        import sys
+        """Make sure we can accurately look up mod line from orig"""
+        patch = parse_patch(self.datafile("diff"))
+        orig = list(self.datafile("orig"))
+        mod = list(self.datafile("mod"))
+        removals = []
+        for i in range(len(orig)):
+            mod_pos = patch.pos_in_mod(i)
+            if mod_pos is None:
+                removals.append(orig[i])
+                continue
+            assert(mod[mod_pos]==orig[i])
+        rem_iter = removals.__iter__()
+        for hunk in patch.hunks:
+            for line in hunk.lines:
+                if isinstance(line, RemoveLine):
+                    next = rem_iter.next()
+                    if line.contents != next:
+                        sys.stdout.write(" orig:%spatch:%s" % (next,
+                                         line.contents))
+                    assert(line.contents == next)
+        self.assertRaises(StopIteration, rem_iter.next)
+
+    def testFirstLineRenumber(self):
+        """Make sure we handle lines at the beginning of the hunk"""
+        patch = parse_patch(self.datafile("insert_top.patch"))
+        assert (patch.pos_in_mod(0)==1)
+
+def test():
+    patchesTestSuite = unittest.makeSuite(PatchesTester,'test')
+    runner = unittest.TextTestRunner(verbosity=0)
+    return runner.run(patchesTestSuite)
+    
+
+if __name__ == "__main__":
+    test()
+# arch-tag: d1541a25-eac5-4de9-a476-08a7cecd5683

=== removed file 'patches.py'
--- patches.py	2005-08-17 18:20:10 +0000
+++ patches.py	1970-01-01 00:00:00 +0000
@@ -1,558 +0,0 @@
-# Copyright (C) 2004, 2005 Aaron Bentley
-# <aaron.bentley@utoronto.ca>
-#
-#    This program is free software; you can redistribute it and/or modify
-#    it under the terms of the GNU General Public License as published by
-#    the Free Software Foundation; either version 2 of the License, or
-#    (at your option) any later version.
-#
-#    This program is distributed in the hope that it will be useful,
-#    but WITHOUT ANY WARRANTY; without even the implied warranty of
-#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#    GNU General Public License for more details.
-#
-#    You should have received a copy of the GNU General Public License
-#    along with this program; if not, write to the Free Software
-#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-class PatchSyntax(Exception):
-    def __init__(self, msg):
-        Exception.__init__(self, msg)
-
-
-class MalformedPatchHeader(PatchSyntax):
-    def __init__(self, desc, line):
-        self.desc = desc
-        self.line = line
-        msg = "Malformed patch header.  %s\n%r" % (self.desc, self.line)
-        PatchSyntax.__init__(self, msg)
-
-class MalformedHunkHeader(PatchSyntax):
-    def __init__(self, desc, line):
-        self.desc = desc
-        self.line = line
-        msg = "Malformed hunk header.  %s\n%r" % (self.desc, self.line)
-        PatchSyntax.__init__(self, msg)
-
-class MalformedLine(PatchSyntax):
-    def __init__(self, desc, line):
-        self.desc = desc
-        self.line = line
-        msg = "Malformed line.  %s\n%s" % (self.desc, self.line)
-        PatchSyntax.__init__(self, msg)
-
-def get_patch_names(iter_lines):
-    try:
-        line = iter_lines.next()
-        if not line.startswith("--- "):
-            raise MalformedPatchHeader("No orig name", line)
-        else:
-            orig_name = line[4:].rstrip("\n")
-    except StopIteration:
-        raise MalformedPatchHeader("No orig line", "")
-    try:
-        line = iter_lines.next()
-        if not line.startswith("+++ "):
-            raise PatchSyntax("No mod name")
-        else:
-            mod_name = line[4:].rstrip("\n")
-    except StopIteration:
-        raise MalformedPatchHeader("No mod line", "")
-    return (orig_name, mod_name)
-
-def parse_range(textrange):
-    """Parse a patch range, handling the "1" special-case
-
-    :param textrange: The text to parse
-    :type textrange: str
-    :return: the position and range, as a tuple
-    :rtype: (int, int)
-    """
-    tmp = textrange.split(',')
-    if len(tmp) == 1:
-        pos = tmp[0]
-        range = "1"
-    else:
-        (pos, range) = tmp
-    pos = int(pos)
-    range = int(range)
-    return (pos, range)
-
- 
-def hunk_from_header(line):
-    if not line.startswith("@@") or not line.endswith("@@\n") \
-        or not len(line) > 4:
-        raise MalformedHunkHeader("Does not start and end with @@.", line)
-    try:
-        (orig, mod) = line[3:-4].split(" ")
-    except Exception, e:
-        raise MalformedHunkHeader(str(e), line)
-    if not orig.startswith('-') or not mod.startswith('+'):
-        raise MalformedHunkHeader("Positions don't start with + or -.", line)
-    try:
-        (orig_pos, orig_range) = parse_range(orig[1:])
-        (mod_pos, mod_range) = parse_range(mod[1:])
-    except Exception, e:
-        raise MalformedHunkHeader(str(e), line)
-    if mod_range < 0 or orig_range < 0:
-        raise MalformedHunkHeader("Hunk range is negative", line)
-    return Hunk(orig_pos, orig_range, mod_pos, mod_range)
-
-
-class HunkLine:
-    def __init__(self, contents):
-        self.contents = contents
-
-    def get_str(self, leadchar):
-        if self.contents == "\n" and leadchar == " " and False:
-            return "\n"
-        if not self.contents.endswith('\n'):
-            terminator = '\n' + NO_NL
-        else:
-            terminator = ''
-        return leadchar + self.contents + terminator
-
-
-class ContextLine(HunkLine):
-    def __init__(self, contents):
-        HunkLine.__init__(self, contents)
-
-    def __str__(self):
-        return self.get_str(" ")
-
-
-class InsertLine(HunkLine):
-    def __init__(self, contents):
-        HunkLine.__init__(self, contents)
-
-    def __str__(self):
-        return self.get_str("+")
-
-
-class RemoveLine(HunkLine):
-    def __init__(self, contents):
-        HunkLine.__init__(self, contents)
-
-    def __str__(self):
-        return self.get_str("-")
-
-NO_NL = '\\ No newline at end of file\n'
-__pychecker__="no-returnvalues"
-
-def parse_line(line):
-    if line.startswith("\n"):
-        return ContextLine(line)
-    elif line.startswith(" "):
-        return ContextLine(line[1:])
-    elif line.startswith("+"):
-        return InsertLine(line[1:])
-    elif line.startswith("-"):
-        return RemoveLine(line[1:])
-    elif line == NO_NL:
-        return NO_NL
-    else:
-        raise MalformedLine("Unknown line type", line)
-__pychecker__=""
-
-
-class Hunk:
-    def __init__(self, orig_pos, orig_range, mod_pos, mod_range):
-        self.orig_pos = orig_pos
-        self.orig_range = orig_range
-        self.mod_pos = mod_pos
-        self.mod_range = mod_range
-        self.lines = []
-
-    def get_header(self):
-        return "@@ -%s +%s @@\n" % (self.range_str(self.orig_pos, 
-                                                   self.orig_range),
-                                    self.range_str(self.mod_pos, 
-                                                   self.mod_range))
-
-    def range_str(self, pos, range):
-        """Return a file range, special-casing for 1-line files.
-
-        :param pos: The position in the file
-        :type pos: int
-        :range: The range in the file
-        :type range: int
-        :return: a string in the format 1,4 except when range == pos == 1
-        """
-        if range == 1:
-            return "%i" % pos
-        else:
-            return "%i,%i" % (pos, range)
-
-    def __str__(self):
-        lines = [self.get_header()]
-        for line in self.lines:
-            lines.append(str(line))
-        return "".join(lines)
-
-    def shift_to_mod(self, pos):
-        if pos < self.orig_pos-1:
-            return 0
-        elif pos > self.orig_pos+self.orig_range:
-            return self.mod_range - self.orig_range
-        else:
-            return self.shift_to_mod_lines(pos)
-
-    def shift_to_mod_lines(self, pos):
-        assert (pos >= self.orig_pos-1 and pos <= self.orig_pos+self.orig_range)
-        position = self.orig_pos-1
-        shift = 0
-        for line in self.lines:
-            if isinstance(line, InsertLine):
-                shift += 1
-            elif isinstance(line, RemoveLine):
-                if position == pos:
-                    return None
-                shift -= 1
-                position += 1
-            elif isinstance(line, ContextLine):
-                position += 1
-            if position > pos:
-                break
-        return shift
-
-def iter_hunks(iter_lines):
-    hunk = None
-    for line in iter_lines:
-        if line == "\n":
-            if hunk is not None:
-                yield hunk
-                hunk = None
-            continue
-        if hunk is not None:
-            yield hunk
-        hunk = hunk_from_header(line)
-        orig_size = 0
-        mod_size = 0
-        while orig_size < hunk.orig_range or mod_size < hunk.mod_range:
-            hunk_line = parse_line(iter_lines.next())
-            hunk.lines.append(hunk_line)
-            if isinstance(hunk_line, (RemoveLine, ContextLine)):
-                orig_size += 1
-            if isinstance(hunk_line, (InsertLine, ContextLine)):
-                mod_size += 1
-    if hunk is not None:
-        yield hunk
-
-class Patch:
-    def __init__(self, oldname, newname):
-        self.oldname = oldname
-        self.newname = newname
-        self.hunks = []
-
-    def __str__(self):
-        ret = self.get_header() 
-        ret += "".join([str(h) for h in self.hunks])
-        return ret
-
-    def get_header(self):
-        return "--- %s\n+++ %s\n" % (self.oldname, self.newname)
-
-    def stats_str(self):
-        """Return a string of patch statistics"""
-        removes = 0
-        inserts = 0
-        for hunk in self.hunks:
-            for line in hunk.lines:
-                if isinstance(line, InsertLine):
-                     inserts+=1;
-                elif isinstance(line, RemoveLine):
-                     removes+=1;
-        return "%i inserts, %i removes in %i hunks" % \
-            (inserts, removes, len(self.hunks))
-
-    def pos_in_mod(self, position):
-        newpos = position
-        for hunk in self.hunks:
-            shift = hunk.shift_to_mod(position)
-            if shift is None:
-                return None
-            newpos += shift
-        return newpos
-            
-    def iter_inserted(self):
-        """Iteraties through inserted lines
-        
-        :return: Pair of line number, line
-        :rtype: iterator of (int, InsertLine)
-        """
-        for hunk in self.hunks:
-            pos = hunk.mod_pos - 1;
-            for line in hunk.lines:
-                if isinstance(line, InsertLine):
-                    yield (pos, line)
-                    pos += 1
-                if isinstance(line, ContextLine):
-                    pos += 1
-
-def parse_patch(iter_lines):
-    (orig_name, mod_name) = get_patch_names(iter_lines)
-    patch = Patch(orig_name, mod_name)
-    for hunk in iter_hunks(iter_lines):
-        patch.hunks.append(hunk)
-    return patch
-
-
-def iter_file_patch(iter_lines):
-    saved_lines = []
-    for line in iter_lines:
-        if line.startswith('*** '):
-            continue
-        elif line.startswith('--- '):
-            if len(saved_lines) > 0:
-                yield saved_lines
-            saved_lines = []
-        saved_lines.append(line)
-    if len(saved_lines) > 0:
-        yield saved_lines
-
-
-def iter_lines_handle_nl(iter_lines):
-    """
-    Iterates through lines, ensuring that lines that originally had no
-    terminating \n are produced without one.  This transformation may be
-    applied at any point up until hunk line parsing, and is safe to apply
-    repeatedly.
-    """
-    last_line = None
-    for line in iter_lines:
-        if line == NO_NL:
-            assert last_line.endswith('\n')
-            last_line = last_line[:-1]
-            line = None
-        if last_line is not None:
-            yield last_line
-        last_line = line
-    if last_line is not None:
-        yield last_line
-
-
-def parse_patches(iter_lines):
-    iter_lines = iter_lines_handle_nl(iter_lines)
-    return [parse_patch(f.__iter__()) for f in iter_file_patch(iter_lines)]
-
-
-def difference_index(atext, btext):
-    """Find the indext of the first character that differs betweeen two texts
-
-    :param atext: The first text
-    :type atext: str
-    :param btext: The second text
-    :type str: str
-    :return: The index, or None if there are no differences within the range
-    :rtype: int or NoneType
-    """
-    length = len(atext)
-    if len(btext) < length:
-        length = len(btext)
-    for i in range(length):
-        if atext[i] != btext[i]:
-            return i;
-    return None
-
-class PatchConflict(Exception):
-    def __init__(self, line_no, orig_line, patch_line):
-        orig = orig_line.rstrip('\n')
-        patch = str(patch_line).rstrip('\n')
-        msg = 'Text contents mismatch at line %d.  Original has "%s",'\
-            ' but patch says it should be "%s"' % (line_no, orig, patch)
-        Exception.__init__(self, msg)
-
-
-def iter_patched(orig_lines, patch_lines):
-    """Iterate through a series of lines with a patch applied.
-    This handles a single file, and does exact, not fuzzy patching.
-    """
-    if orig_lines is not None:
-        orig_lines = orig_lines.__iter__()
-    seen_patch = []
-    patch_lines = iter_lines_handle_nl(patch_lines.__iter__())
-    get_patch_names(patch_lines)
-    line_no = 1
-    for hunk in iter_hunks(patch_lines):
-        while line_no < hunk.orig_pos:
-            orig_line = orig_lines.next()
-            yield orig_line
-            line_no += 1
-        for hunk_line in hunk.lines:
-            seen_patch.append(str(hunk_line))
-            if isinstance(hunk_line, InsertLine):
-                yield hunk_line.contents
-            elif isinstance(hunk_line, (ContextLine, RemoveLine)):
-                orig_line = orig_lines.next()
-                if orig_line != hunk_line.contents:
-                    raise PatchConflict(line_no, orig_line, "".join(seen_patch))
-                if isinstance(hunk_line, ContextLine):
-                    yield orig_line
-                else:
-                    assert isinstance(hunk_line, RemoveLine)
-                line_no += 1
-                    
-import unittest
-import os.path
-class PatchesTester(unittest.TestCase):
-    def datafile(self, filename):
-        data_path = os.path.join(os.path.dirname(__file__), "testdata", 
-                                 filename)
-        return file(data_path, "rb")
-
-    def testValidPatchHeader(self):
-        """Parse a valid patch header"""
-        lines = "--- orig/commands.py\n+++ mod/dommands.py\n".split('\n')
-        (orig, mod) = get_patch_names(lines.__iter__())
-        assert(orig == "orig/commands.py")
-        assert(mod == "mod/dommands.py")
-
-    def testInvalidPatchHeader(self):
-        """Parse an invalid patch header"""
-        lines = "-- orig/commands.py\n+++ mod/dommands.py".split('\n')
-        self.assertRaises(MalformedPatchHeader, get_patch_names,
-                          lines.__iter__())
-
-    def testValidHunkHeader(self):
-        """Parse a valid hunk header"""
-        header = "@@ -34,11 +50,6 @@\n"
-        hunk = hunk_from_header(header);
-        assert (hunk.orig_pos == 34)
-        assert (hunk.orig_range == 11)
-        assert (hunk.mod_pos == 50)
-        assert (hunk.mod_range == 6)
-        assert (str(hunk) == header)
-
-    def testValidHunkHeader2(self):
-        """Parse a tricky, valid hunk header"""
-        header = "@@ -1 +0,0 @@\n"
-        hunk = hunk_from_header(header);
-        assert (hunk.orig_pos == 1)
-        assert (hunk.orig_range == 1)
-        assert (hunk.mod_pos == 0)
-        assert (hunk.mod_range == 0)
-        assert (str(hunk) == header)
-
-    def makeMalformed(self, header):
-        self.assertRaises(MalformedHunkHeader, hunk_from_header, header)
-
-    def testInvalidHeader(self):
-        """Parse an invalid hunk header"""
-        self.makeMalformed(" -34,11 +50,6 \n")
-        self.makeMalformed("@@ +50,6 -34,11 @@\n")
-        self.makeMalformed("@@ -34,11 +50,6 @@")
-        self.makeMalformed("@@ -34.5,11 +50,6 @@\n")
-        self.makeMalformed("@@-34,11 +50,6@@\n")
-        self.makeMalformed("@@ 34,11 50,6 @@\n")
-        self.makeMalformed("@@ -34,11 @@\n")
-        self.makeMalformed("@@ -34,11 +50,6.5 @@\n")
-        self.makeMalformed("@@ -34,11 +50,-6 @@\n")
-
-    def lineThing(self,text, type):
-        line = parse_line(text)
-        assert(isinstance(line, type))
-        assert(str(line)==text)
-
-    def makeMalformedLine(self, text):
-        self.assertRaises(MalformedLine, parse_line, text)
-
-    def testValidLine(self):
-        """Parse a valid hunk line"""
-        self.lineThing(" hello\n", ContextLine)
-        self.lineThing("+hello\n", InsertLine)
-        self.lineThing("-hello\n", RemoveLine)
-    
-    def testMalformedLine(self):
-        """Parse invalid valid hunk lines"""
-        self.makeMalformedLine("hello\n")
-    
-    def compare_parsed(self, patchtext):
-        lines = patchtext.splitlines(True)
-        patch = parse_patch(lines.__iter__())
-        pstr = str(patch)
-        i = difference_index(patchtext, pstr)
-        if i is not None:
-            print "%i: \"%s\" != \"%s\"" % (i, patchtext[i], pstr[i])
-        self.assertEqual (patchtext, str(patch))
-
-    def testAll(self):
-        """Test parsing a whole patch"""
-        patchtext = """--- orig/commands.py
-+++ mod/commands.py
-@@ -1337,7 +1337,8 @@
- 
-     def set_title(self, command=None):
-         try:
--            version = self.tree.tree_version.nonarch
-+            version = pylon.alias_or_version(self.tree.tree_version, self.tree,
-+                                             full=False)
-         except:
-             version = "[no version]"
-         if command is None:
-@@ -1983,7 +1984,11 @@
-                                          version)
-         if len(new_merges) > 0:
-             if cmdutil.prompt("Log for merge"):
--                mergestuff = cmdutil.log_for_merge(tree, comp_version)
-+                if cmdutil.prompt("changelog for merge"):
-+                    mergestuff = "Patches applied:\\n"
-+                    mergestuff += pylon.changelog_for_merge(new_merges)
-+                else:
-+                    mergestuff = cmdutil.log_for_merge(tree, comp_version)
-                 log.description += mergestuff
-         log.save()
-     try:
-"""
-        self.compare_parsed(patchtext)
-
-    def testInit(self):
-        """Handle patches missing half the position, range tuple"""
-        patchtext = \
-"""--- orig/__init__.py
-+++ mod/__init__.py
-@@ -1 +1,2 @@
- __docformat__ = "restructuredtext en"
-+__doc__ = An alternate Arch commandline interface
-"""
-        self.compare_parsed(patchtext)
-        
-
-
-    def testLineLookup(self):
-        import sys
-        """Make sure we can accurately look up mod line from orig"""
-        patch = parse_patch(self.datafile("diff"))
-        orig = list(self.datafile("orig"))
-        mod = list(self.datafile("mod"))
-        removals = []
-        for i in range(len(orig)):
-            mod_pos = patch.pos_in_mod(i)
-            if mod_pos is None:
-                removals.append(orig[i])
-                continue
-            assert(mod[mod_pos]==orig[i])
-        rem_iter = removals.__iter__()
-        for hunk in patch.hunks:
-            for line in hunk.lines:
-                if isinstance(line, RemoveLine):
-                    next = rem_iter.next()
-                    if line.contents != next:
-                        sys.stdout.write(" orig:%spatch:%s" % (next,
-                                         line.contents))
-                    assert(line.contents == next)
-        self.assertRaises(StopIteration, rem_iter.next)
-
-    def testFirstLineRenumber(self):
-        """Make sure we handle lines at the beginning of the hunk"""
-        patch = parse_patch(self.datafile("insert_top.patch"))
-        assert (patch.pos_in_mod(0)==1)
-
-def test():
-    patchesTestSuite = unittest.makeSuite(PatchesTester,'test')
-    runner = unittest.TextTestRunner(verbosity=0)
-    return runner.run(patchesTestSuite)
-    
-
-if __name__ == "__main__":
-    test()
-# arch-tag: d1541a25-eac5-4de9-a476-08a7cecd5683

=== modified file 'push.py'
--- push.py	2005-08-26 00:15:55 +0000
+++ push.py	2005-10-24 13:48:44 +0000
@@ -15,19 +15,24 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 from bzrlib.branch import Branch
 from bzrlib.commands import Command
+from bzrlib.option import Option
 import sys
 import os
 import bzrtools 
 
+
 class cmd_push(Command):
     """Upload this branch to another location using rsync.
 
-    If no location is specified, the last-used location will be used.  To
-    to prevent dirty trees from being uploaded, push will error out if there
-    are unknown files or local changes.
+    If no location is specified, the last-used location will be used.  To 
+    prevent dirty trees from being uploaded, push will error out if there are 
+    unknown files or local changes.  It will also error out if the upstream 
+    directory is non-empty and not an earlier version of the branch. 
     """
     takes_args = ['location?']
+    takes_options = [Option('overwrite', help='Ignore differences between'
+                            ' branches and overwrite unconditionally')]
 
-    def run(self, location=None):
-        cur_branch = Branch(".")
-        bzrtools.push(cur_branch, location)
+    def run(self, location=None, overwrite=False):
+        cur_branch = Branch.open_containing(".")[0]
+        bzrtools.push(cur_branch, location, overwrite=overwrite)

=== added file 'setup.py'
--- setup.py	1970-01-01 00:00:00 +0000
+++ setup.py	2005-10-29 18:40:34 +0000
@@ -0,0 +1,10 @@
+from distutils.core import setup
+setup(name="BzrTools",
+      version="0.6",
+      description="Handy utilities for working with BZR(Bazaar-NG).",
+      author="Aaron Bentley",
+      author_email="aaron.bentley@utoronto.ca",
+      license = "GNU GPL v2"
+      url="http://bazaar.canonical.com/BzrTools",
+      packages=['bzrlib.plugins.bzrtools'],
+      package_dir={'bzrlib.plugins.bzrtools': '.'})

=== removed file 'shelf.py'
--- shelf.py	2005-08-25 01:51:22 +0000
+++ shelf.py	1970-01-01 00:00:00 +0000
@@ -1,361 +0,0 @@
-#!/usr/bin/python
-
-from patches import parse_patches
-import os
-import sys
-import string
-import tty, termios
-import glob
-from bzrlib.commands import Command
-
-def main(args):
-    name = os.path.basename(args.pop(0))
-
-    if name not in ['shelve', 'unshelve']:
-        raise Exception("Unknown command name '%s'" % name)
-
-    if len(args) > 0:
-        if args[0] == '--bzr-usage':
-            print '\n'
-            return 0
-        elif args[0] == '--bzr-help':
-            print 'Shelve a patch, you can get it back later with unshelve.'
-            return 0
-        else:
-            raise Exception("Don't understand args %s" % args)
-
-    if eval(name + "()"):
-        return 0
-
-    return 1
-
-def tree_root():
-    return run_bzr('root')[0].strip()
-
-def shelf_suffix(index):
-    if index == 0:
-        return ""
-    else:
-        return "-%d" % index
-
-def next_shelf():
-    def name_sequence():
-        i = 0
-        while True:
-            yield shelf_suffix(i)
-            i = i + 1
-
-    stem = os.path.join(tree_root(), '.bzr-shelf')
-    for end in name_sequence():
-        name = stem + end
-        if not os.path.exists(name):
-            return name
-
-def last_shelf():
-    stem = os.path.join(tree_root(), '.bzr-shelf')
-    shelves = glob.glob(stem)
-    shelves.extend(glob.glob(stem + '-*'))
-    def shelf_index(name):
-        if name == stem:
-            return 0
-        return int(name[len(stem)+1:])
-    shelvenums = [shelf_index(f) for f in shelves]
-    shelvenums.sort()
-
-    if len(shelvenums) == 0:
-        return None
-    return stem + shelf_suffix(shelvenums[-1])
-
-def get_shelf_message(shelf):
-    prefix = "# shelf: "
-    if not shelf.startswith(prefix):
-        return None
-    return shelf[len(prefix):shelf.index('\n')]
-
-def unshelve():
-    shelf = last_shelf()
-
-    if shelf is None:
-        raise Exception("No shelf found in '%s'" % tree_root())
-
-    patch = open(shelf, 'r').read()
-
-    print >>sys.stderr, "Reapplying shelved patches",
-    message = get_shelf_message(patch)
-    if message is not None:
-        print >>sys.stderr, ' "%s"' % message
-    else:
-        print >>sys.stderr, ""
-    pipe = os.popen('patch -d %s -s -p0' % tree_root(), 'w')
-    pipe.write(patch)
-    pipe.flush()
-
-    if pipe.close() is not None:
-        raise Exception("Failed running patch!")
-
-    os.remove(shelf)
-    print 'Diff status is now:'
-    os.system('bzr diff | diffstat')
-
-    return True
-
-class QuitException(Exception):
-    pass
-
-def shelve(message = None, revision = None, file_list = None):
-    cmd = ['diff']
-    if revision is not None:
-        cmd.extend(['--revision', str(revision[0])])
-    if file_list is not None:
-        cmd.extend(file_list)
-    patches = parse_patches(run_bzr(cmd))
-    try:
-        patches = HunkSelector(patches).select()
-    except QuitException:
-        return False
-
-    if len(patches) == 0:
-        print >>sys.stderr, 'Nothing to shelve'
-        return True
-
-    shelf = next_shelf()
-    print >>sys.stderr, "Saving shelved patches to", shelf
-    shelf = open(shelf, 'a')
-    if message is not None:
-        assert '\n' not in message
-        shelf.write("# shelf: %s\n" % message)
-    for patch in patches:
-        shelf.write(str(patch))
-
-    shelf.flush()
-    os.fsync(shelf.fileno())
-    shelf.close()
-
-    print >>sys.stderr, "Reverting shelved patches"
-    pipe = os.popen('patch -d %s -sR -p0' % tree_root(), 'w')
-    for patch in patches:
-       pipe.write(str(patch))
-    pipe.flush()
-
-    if pipe.close() is not None:
-        raise Exception("Failed running patch!")
-
-    print 'Diff status is now:'
-    os.system('bzr diff | diffstat')
-
-    return True
-
-def run_bzr(args):
-    if type(args) is str:
-        args = [ args ]
-    pipe = os.popen('bzr %s' % string.join(args, ' '), 'r')
-    lines = pipe.readlines()
-    if pipe.close() is not None:
-        raise Exception("Failed running bzr")
-    return lines
-
-class cmd_shelve(Command):
-    """Temporarily remove some changes from the current tree.
-    Use 'unshelve' to restore these changes.
-
-    If filenames are specified, only changes to those files will be unshelved.
-    If a revision is specified, all changes since that revision will may be
-    unshelved.
-    """
-    takes_args = ['file*']
-    takes_options = ['message', 'revision']
-    def run(self, file_list=None, message=None, revision=None):
-        return shelve(message=message, file_list=file_list, revision=revision)
-
-class cmd_unshelve(Command):
-    """Restore previously-shelved changes to the current tree.
-    See also 'shelve'.
-    """
-    def run(self):
-        return unshelve()
-
-class HunkSelector:
-    class Option:
-        def __init__(self, char, action, help, default=False):
-            self.char = char
-            self.action = action
-            self.default = default
-            self.help = help
-
-    standard_options = [
-        Option('n', 'shelve', 'shelve this change for the moment.',
-            default=True),
-        Option('y', 'keep', 'keep this change in your tree.'),
-        Option('d', 'done', 'done, skip to the end.'),
-        Option('i', 'invert', 'invert the current selection of all hunks.'),
-        Option('s', 'status', 'show status of hunks.'),
-        Option('q', 'quit', 'quit')
-    ]
-
-    end_options = [
-        Option('y', 'continue', 'proceed to shelve selected changes.',
-            default=True),
-        Option('r', 'restart', 'restart the hunk selection loop.'),
-        Option('s', 'status', 'show status of hunks.'),
-        Option('i', 'invert', 'invert the current selection of all hunks.'),
-        Option('q', 'quit', 'quit')
-    ]
-
-    def __init__(self, patches):
-        self.patches = patches
-        self.total_hunks = 0
-        for patch in patches:
-            for hunk in patch.hunks:
-                # everything's shelved by default
-                hunk.selected = True
-                self.total_hunks += 1
-
-    def __get_option(self, char):
-        for opt in self.standard_options:
-            if opt.char == char:
-                return opt
-        raise Exception('Option "%s" not found!' % char)
-
-    def __select_loop(self):
-        j = 0
-        for patch in self.patches:
-            i = 0
-            lasti = -1
-            while i < len(patch.hunks):
-                hunk = patch.hunks[i]
-                if lasti != i:
-                    print patch.get_header(), hunk
-                    j += 1
-                lasti = i
-
-                prompt = 'Keep this change? (%d of %d)' \
-                            % (j, self.total_hunks)
-
-                if hunk.selected:
-                    self.__get_option('n').default = True
-                    self.__get_option('y').default = False
-                else:
-                    self.__get_option('n').default = False
-                    self.__get_option('y').default = True
-
-                action = self.__ask_user(prompt, self.standard_options)
-
-                if action == 'keep':
-                    hunk.selected = False
-                elif action == 'shelve':
-                    hunk.selected = True
-                elif action == 'done':
-                    return True
-                elif action == 'invert':
-                    self.__invert_selection()
-                    self.__show_status()
-                    continue
-                elif action == 'status':
-                    self.__show_status()
-                    continue
-                elif action == 'quit':
-                    return False
-
-                i += 1
-        return True
-
-    def select(self):
-        if self.total_hunks == 0:
-            return []
-
-        done = False
-        while not done:
-            if not self.__select_loop():
-                return []
-
-            while True:
-                self.__show_status()
-                prompt = "Shelve these changes, or restart?"
-                action = self.__ask_user(prompt, self.end_options)
-
-                if action == 'continue':
-                    done = True
-                    break
-                elif action == 'quit':
-                    return []
-                elif action == 'status':
-                    self.__show_status()
-                elif action == 'invert':
-                    self.__invert_selection()
-                elif action == 'restart':
-                    break
-
-
-        for patch in self.patches:
-            tmp = []
-            for hunk in patch.hunks:
-                if hunk.selected:
-                    tmp.append(hunk)
-            patch.hunks = tmp
-
-        tmp = []
-        for patch in self.patches:
-            if len(patch.hunks):
-                tmp.append(patch)
-        self.patches = tmp
-
-        return self.patches
-
-    def __invert_selection(self):
-        for patch in self.patches:
-            for hunk in patch.hunks:
-                if hunk.__dict__.has_key('selected'):
-                    hunk.selected = not hunk.selected
-                else:
-                    hunk.selected = True
-
-    def __show_status(self):
-        print '\nStatus:'
-        for patch in self.patches:
-            print '  %s' % patch.oldname
-            shelve = 0
-            keep = 0
-            for hunk in patch.hunks:
-                if hunk.selected:
-                    shelve += 1
-                else:
-                    keep += 1
-
-            print '    %d hunks to be shelved' % shelve
-            print '    %d hunks to be kept' % keep
-            print
-
-    def __getchar(self):
-        fd = sys.stdin.fileno()
-        settings = termios.tcgetattr(fd)
-        try:
-            tty.setraw(fd)
-            ch = sys.stdin.read(1)
-        finally:
-            termios.tcsetattr(fd, termios.TCSADRAIN, settings)
-        return ch
-
-    def __ask_user(self, prompt, options):
-        while True:
-            sys.stdout.write(prompt)
-            sys.stdout.write(' [')
-            for opt in options:
-                if opt.default:
-                    default = opt
-                sys.stdout.write(opt.char)
-            sys.stdout.write('?] (%s): ' % default.char)
-
-            response = self.__getchar()
-
-            # default, which we see as newline, is 'n'
-            if response in ['\n', '\r', '\r\n']:
-                response = default.char
-
-            print response # because echo is off
-
-            for opt in options:
-                if opt.char == response:
-                    return opt.action
-
-            for opt in options:
-                print '  %s - %s' % (opt.char, opt.help)

=== added file 'shelf.py'
--- shelf.py	1970-01-01 00:00:00 +0000
+++ shelf.py	2005-10-26 09:49:08 +0000
@@ -0,0 +1,140 @@
+#!/usr/bin/python
+
+from patches import parse_patches
+import os
+import sys
+import string
+import glob
+import bzrlib
+from bzrlib.commands import Command
+from bzrlib.branch import Branch
+from bzrlib import DEFAULT_IGNORE
+from hunk_selector import HunkSelector
+from diffstat import DiffStat
+
+DEFAULT_IGNORE.append('./.bzr-shelf*')
+
+class QuitException(Exception):
+    pass
+
+class Shelf(object):
+    def __init__(self, location):
+        self.branch = Branch.open_containing(location)[0]
+
+    def shelf_suffix(self, index):
+        if index == 0:
+            return ""
+        else:
+            return "-%d" % index
+
+    def next_shelf(self):
+        def name_sequence():
+            i = 0
+            while True:
+                yield self.shelf_suffix(i)
+                i = i + 1
+
+        stem = os.path.join(self.branch.base, '.bzr-shelf')
+        for end in name_sequence():
+            name = stem + end
+            if not os.path.exists(name):
+                return name
+
+    def last_shelf(self):
+        stem = os.path.join(self.branch.base, '.bzr-shelf')
+        shelves = glob.glob(stem)
+        shelves.extend(glob.glob(stem + '-*'))
+        def shelf_index(name):
+            if name == stem:
+                return 0
+            return int(name[len(stem)+1:])
+        shelvenums = [shelf_index(f) for f in shelves]
+        shelvenums.sort()
+
+        if len(shelvenums) == 0:
+            return None
+        return stem + self.shelf_suffix(shelvenums[-1])
+
+    def get_shelf_message(self, shelf):
+        prefix = "# shelf: "
+        if not shelf.startswith(prefix):
+            return None
+        return shelf[len(prefix):shelf.index('\n')]
+
+    def unshelve(self):
+        shelf = self.last_shelf()
+
+        if shelf is None:
+            raise Exception("No shelf found in '%s'" % self.branch.base)
+
+        patch = open(shelf, 'r').read()
+
+        print >>sys.stderr, "Reapplying shelved patches",
+        message = self.get_shelf_message(patch)
+        if message is not None:
+            print >>sys.stderr, ' "%s"' % message
+        else:
+            print >>sys.stderr, ""
+        pipe = os.popen('patch -d %s -s -p0' % self.branch.base, 'w')
+        pipe.write(patch)
+        pipe.flush()
+
+        if pipe.close() is not None:
+            raise Exception("Failed running patch!")
+
+        os.remove(shelf)
+
+        diff_stat = DiffStat(self.get_patches(None, None))
+        print 'Diff status is now:\n', diff_stat
+
+        return True
+
+    def get_patches(self, revision, file_list):
+        from StringIO import StringIO
+        from bzrlib.diff import show_diff
+        out = StringIO()
+        show_diff(self.branch, revision, specific_files=file_list, output=out)
+        out.seek(0)
+        return out.readlines()
+
+    def shelve(self, all_hunks=False, message=None, revision=None,
+             file_list=None):
+        patches = parse_patches(self.get_patches(revision, file_list))
+
+        if not all_hunks:
+            try:
+                patches = HunkSelector(patches).select()
+            except QuitException:
+                return False
+
+        if len(patches) == 0:
+            print >>sys.stderr, 'Nothing to shelve'
+            return True
+
+        shelf = self.next_shelf()
+        print >>sys.stderr, "Saving shelved patches to", shelf
+        shelf = open(shelf, 'a')
+        if message is not None:
+            assert '\n' not in message
+            shelf.write("# shelf: %s\n" % message)
+        for patch in patches:
+            shelf.write(str(patch))
+
+        shelf.flush()
+        os.fsync(shelf.fileno())
+        shelf.close()
+
+        print >>sys.stderr, "Reverting shelved patches"
+        pipe = os.popen('patch -d %s -sR -p0' % self.branch.base, 'w')
+        for patch in patches:
+            pipe.write(str(patch))
+        pipe.flush()
+
+        if pipe.close() is not None:
+            raise Exception("Failed running patch!")
+
+        diff_stat = DiffStat(self.get_patches(None, None))
+        print 'Diff status is now:\n', diff_stat
+
+        return True
+

=== added file 'shelf_tests.py'
--- shelf_tests.py	1970-01-01 00:00:00 +0000
+++ shelf_tests.py	2005-10-26 14:39:40 +0000
@@ -0,0 +1,119 @@
+#!/usr/bin/python
+
+import bzrlib.selftest
+
+class ShelfTests(bzrlib.selftest.TestCaseInTempDir):
+    ORIGINAL = '\n\nhello test world\n\n'
+    MODIFIED = '\n\ngoodbye test world\n\n'
+    DIFF_HEADER = "=== modified file 'test_file'\n"
+    DIFF_1 = """--- test_file
++++ test_file
+@@ -1,4 +1,4 @@
+ 
+ 
+-hello test world
++goodbye test world
+ 
+"""
+    DIFF_2 = """--- test_file
++++ test_file
+@@ -1,4 +1,4 @@
+ 
+ 
+-goodbye test world
++hello test world
+ 
+"""
+    def test_shelf(self):
+        from bzrlib.branch import Branch
+        b = Branch.initialize('.')
+
+        # Create a test file and commit it
+        file('test_file', 'w').write(self.ORIGINAL)
+        b.add('test_file')
+        b.commit(message='add test_file')
+
+        # Modify the test file
+        file('test_file', 'w').write(self.MODIFIED)
+
+        # Check the diff is right
+        self.assertEqual(self.capture('diff'),
+            self.DIFF_HEADER + self.DIFF_1 + '\n')
+
+        # Shelve the changes
+        self.run_bzr('shelve', '--all', retcode=True)
+
+        # Make sure there is no diff anymore
+        self.assertEqual(self.capture('diff'), '')
+
+        # Make sure the file is actually back the way it was
+        self.assertEqual(file('test_file').read(), self.ORIGINAL)
+
+        # Check the shelf is right
+        shelf = file('.bzr-shelf').read()
+        self.assertEqual(shelf, self.DIFF_1)
+
+        # Unshelve
+        self.run_bzr('unshelve', retcode=True)
+
+        # Check the diff is right again
+        self.assertEqual(self.capture('diff'),
+            self.DIFF_HEADER + self.DIFF_1 + '\n')
+
+        # Make sure the file is back the way it should be
+        self.assertEqual(file('test_file').read(), self.MODIFIED)
+
+    def test_shelf_nothing_to_shelve(self):
+        import os.path
+        from bzrlib.branch import Branch
+        b = Branch.initialize('.')
+
+        # Create a test file and commit it
+        file('test_file', 'w').write(self.ORIGINAL)
+        b.add('test_file')
+        b.commit(message='add test_file')
+
+        # Shelve the changes
+        self.run_bzr('shelve', '--all', retcode=True)
+
+        if os.path.exists('.bzr-shelf'):
+            self.fail("Shelf exists, but it shouldn't")
+
+    def test_shelf_with_revision(self):
+        from bzrlib.branch import Branch
+        b = Branch.initialize('.')
+
+        # Create a test file and commit it
+        file('test_file', 'w').write(self.ORIGINAL)
+        b.add('test_file')
+        b.commit(message='add test_file')
+
+        # Modify the test file and commit it
+        file('test_file', 'w').write(self.MODIFIED)
+        b.commit(message='update test_file')
+
+        # Shelve the changes
+        self.run_bzr('shelve', '-r', '1', '--all', retcode=True)
+
+        # Check the diff is right
+        self.assertEqual(self.capture('diff'),
+            self.DIFF_HEADER + self.DIFF_2 + '\n')
+
+        # Make sure the file is the way it should be
+        self.assertEqual(file('test_file').read(), self.ORIGINAL)
+
+        # Unshelve
+        self.run_bzr('unshelve', retcode=True)
+
+        # Make sure the file is back the way it should be
+        self.assertEqual(file('test_file').read(), self.MODIFIED)
+
+    def test_shelf_with_two_revisions(self):
+        from bzrlib.branch import Branch
+        b = Branch.initialize('.')
+
+        cmd = 'shelve -r 1..2'
+        (stdout, stderr) = self.run_bzr_captured(cmd.split(), retcode=None)
+
+        self.assertEqual(stderr.split('\n')[0],
+            'bzr: ERROR: shelve only accepts a single revision parameter.')

=== added file 'shell.py'
--- shell.py	1970-01-01 00:00:00 +0000
+++ shell.py	2005-10-29 04:53:42 +0000
@@ -0,0 +1,298 @@
+# Copyright (C) 2004, 2005 Aaron Bentley
+# <aaron.bentley@utoronto.ca>
+#
+#    This program is free software; you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation; either version 2 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program; if not, write to the Free Software
+#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+import cmd
+import sys
+import os
+import terminal
+import readline
+import string
+from itertools import chain
+from bzrlib.errors import BzrError
+from bzrlib.commands import get_cmd_object, get_all_cmds
+
+SHELL_BLACKLIST = set(['rm', 'ls'])
+COMPLETION_BLACKLIST = set(['shell'])
+
+class BlackListedCommand(BzrError):
+    def __init__(self, command):
+        BzrError.__init__(self, "The command %s is blacklisted for shell use" %
+                          command)
+
+class CompletionContext(object):
+    def __init__(self, text, command=None, prev_opt=None, arg_pos=None):
+        self.text = text
+        self.command = command
+        self.prev_opt = prev_opt
+        self.arg_pos = None
+
+    def get_completions(self):
+        if not command:
+            iter = (c for c in iter_command_names() if
+                    c not in COMPLETION_BLACKLIST)
+            try:
+                if len(line) > 0:
+                    arg = line.split()[-1]
+                else:
+                    arg = ""
+                iter = list(iter_munged_completions(iter, arg, text))
+            except Exception, e:
+                print e, type(e)
+
+
+
+class PromptCmd(cmd.Cmd):
+    def __init__(self):
+        cmd.Cmd.__init__(self)
+        self.prompt = "bzr> "
+        try:
+            self.tree = arch.tree_root(".")
+        except:
+            self.tree = None
+        self.set_title()
+        self.set_prompt()
+        self.identchars += '-'
+        self.history_file = os.path.expanduser("~/.bazaar/shell-history")
+        readline.set_completer_delims(string.whitespace)
+        if os.access(self.history_file, os.R_OK) and \
+            os.path.isfile(self.history_file):
+            readline.read_history_file(self.history_file)
+        self.cwd = os.getcwd()
+
+    def write_history(self):
+        readline.write_history_file(self.history_file)
+
+    def do_quit(self, args):
+        self.write_history()
+        raise StopIteration
+
+    def do_exit(self, args):
+        self.do_quit(args)
+
+    def do_EOF(self, args):
+        print
+        self.do_quit(args)
+
+    def postcmd(self, line, bar):
+        self.set_title()
+        self.set_prompt()
+
+    def set_prompt(self):
+        if self.tree is not None:
+            try:
+                prompt = pylon.alias_or_version(self.tree.tree_version, 
+                                                self.tree, 
+                                                full=False)
+                if prompt is not None:
+                    prompt = " " + prompt +":"+ pylon.tree_cwd(self.tree)
+            except:
+                prompt = ""
+        else:
+            prompt = ""
+        self.prompt = "bzr%s> " % prompt
+
+    def set_title(self, command=None):
+        try:
+            version = pylon.alias_or_version(self.tree.tree_version, self.tree, 
+                                             full=False)
+        except:
+            version = "[no version]"
+        if command is None:
+            command = ""
+        sys.stdout.write(terminal.term_title("bzr %s %s" % (command, version)))
+
+    def do_cd(self, line):
+        if line == "":
+            line = "~"
+        line = os.path.expanduser(line)
+        if os.path.isabs(line):
+            newcwd = line
+        else:
+            newcwd = self.cwd+'/'+line
+        newcwd = os.path.normpath(newcwd)
+        try:
+            os.chdir(newcwd)
+            self.cwd = newcwd
+        except Exception, e:
+            print e
+        try:
+            self.tree = arch.tree_root(".")
+        except:
+            self.tree = None
+
+    def do_help(self, line):
+        self.default("help "+line)
+
+    def default(self, line):
+        args = line.split()
+        commandname = args.pop(0)
+        for char in ('|', '<', '>'):
+            commandname = commandname.split(char)[0]
+        if commandname[-1] in ('|', '<', '>'):
+            commandname = commandname[:-1]
+        try:
+            if commandname in SHELL_BLACKLIST:
+                raise BlackListedCommand(commandname)
+            cmd_obj = get_cmd_object(commandname)
+        except (BlackListedCommand, BzrError):
+            return os.system(line)
+
+        try:
+            if too_complicated(line):
+                return os.system("bzr "+line)
+            else:
+                return (cmd_obj.run_argv(args) or 0)
+        except BzrError, e:
+            print e
+        except KeyboardInterrupt, e:
+            print "Interrupted"
+        except Exception, e:
+#            print "Unhandled error:\n%s" % errors.exception_str(e)
+            print "Unhandled error:\n%s" % (e)
+
+
+    def completenames(self, text, line, begidx, endidx):
+        completions = []
+        iter = (c for c in iter_command_names() if
+                c not in COMPLETION_BLACKLIST)
+        try:
+            if len(line) > 0:
+                arg = line.split()[-1]
+            else:
+                arg = ""
+            iter = list(iter_munged_completions(iter, arg, text))
+        except Exception, e:
+            print e, type(e)
+        return list(iter)
+
+    def completedefault(self, text, line, begidx, endidx):
+        """Perform completion for native commands.
+        
+        :param text: The text to complete
+        :type text: str
+        :param line: The entire line to complete
+        :type line: str
+        :param begidx: The start of the text in the line
+        :type begidx: int
+        :param endidx: The end of the text in the line
+        :type endidx: int
+        """
+        (cmd, args, foo) = self.parseline(line)
+        if cmd == "bzr":
+            try:
+                return self.completenames(text, line, begidx, endidx)
+            except Exception, e:
+                print e
+        try:
+            command_obj = get_cmd_object(cmd)
+        except BzrError:
+            command_obj = None
+        try:
+            if command_obj is not None:
+                opts = []
+                for option_name, option in command_obj.options().items():
+                    opts.append("--" + option_name)
+                    short_name = option.short_name()
+                    if short_name:
+                        opts.append("-" + short_name)
+                q = list(iter_munged_completions(opts, args, text))
+                return list(iter_munged_completions(opts, args, text))
+            elif cmd == "cd":
+                if len(args) > 0:
+                    arg = args.split()[-1]
+                else:
+                    arg = ""
+                iter = iter_dir_completions(arg)
+                iter = iter_munged_completions(iter, arg, text)
+                return list(iter)
+            elif len(args)>0:
+                arg = args.split()[-1]
+                iter = iter_file_completions(arg)
+                return list(iter_munged_completions(iter, arg, text))
+            else:
+                return self.completenames(text, line, begidx, endidx)
+        except Exception, e:
+            print e
+
+def run_shell():
+    try:
+        prompt = PromptCmd()
+        try:
+            prompt.cmdloop()
+        finally:
+            prompt.write_history()
+    except StopIteration:
+        pass
+
+def iter_file_completions(arg, only_dirs = False):
+    """Generate an iterator that iterates through filename completions.
+
+    :param arg: The filename fragment to match
+    :type arg: str
+    :param only_dirs: If true, match only directories
+    :type only_dirs: bool
+    """
+    cwd = os.getcwd()
+    if cwd != "/":
+        extras = [".", ".."]
+    else:
+        extras = []
+    (dir, file) = os.path.split(arg)
+    if dir != "":
+        listingdir = os.path.expanduser(dir)
+    else:
+        listingdir = cwd
+    for file in chain(os.listdir(listingdir), extras):
+        if dir != "":
+            userfile = dir+'/'+file
+        else:
+            userfile = file
+        if userfile.startswith(arg):
+            if os.path.isdir(listingdir+'/'+file):
+                userfile+='/'
+                yield userfile
+            elif not only_dirs:
+                yield userfile
+
+
+def iter_dir_completions(arg):
+    """Generate an iterator that iterates through directory name completions.
+
+    :param arg: The directory name fragment to match
+    :type arg: str
+    """
+    return iter_file_completions(arg, True)
+
+def iter_command_names(hidden=False):
+    for real_cmd_name, cmd_class in get_all_cmds():
+        if not hidden and cmd_class.hidden:
+            continue
+        for name in [real_cmd_name] + cmd_class.aliases:
+            # Don't complete on aliases that are prefixes of the canonical name
+            if name == real_cmd_name or not real_cmd_name.startswith(name):
+                yield name
+
+def iter_munged_completions(iter, arg, text):
+    for completion in iter:
+        completion = str(completion)
+        if completion.startswith(arg):
+            yield completion[len(arg)-len(text):]+" "
+
+def too_complicated(line):
+    for char in '|<>"\"*?':
+        if char in line:
+            return True
+    return False

=== added file 'terminal.py'
--- terminal.py	1970-01-01 00:00:00 +0000
+++ terminal.py	2005-10-27 04:45:06 +0000
@@ -0,0 +1,71 @@
+# Copyright (C) 2004 Aaron Bentley
+# <aaron.bentley@utoronto.ca>
+#
+#    This program is free software; you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation; either version 2 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program; if not, write to the Free Software
+#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+
+__docformat__ = "restructuredtext"
+__doc__ = "Terminal control functionality"
+
+def has_ansi_colors():
+    # XXX The whole color handling should be rewritten to use terminfo
+    # XXX before we get there, checking for setaf capability should do.
+    # XXX See terminfo(5) for all the gory details.
+    import curses
+    curses.setupterm()
+    return bool(curses.tigetstr('setaf'))
+
+colors = {
+"black": "0",
+"red": "1",
+"green": "2",
+"yellow": "3",
+"blue": "4",
+"magenta": "5",
+"cyan": "6",
+"white": "7"
+}
+
+def colorstring(text, fgcolor=None, bright=False, bgcolor=None):
+    """
+    Returns a string using ANSI control codes to set the text color.
+
+    :param text: The text to set the color for.
+    :type text: string
+    :param fgcolor: The foreground color to use
+    :type fgcolor: string
+    :param bright: If true, make the foreground color bright
+    :type bright: bool
+    :param bgcolor: The background color to use
+    :type bgcolor: string
+    """
+    code = []
+    if (bright): 
+        code.append("1")
+    if (fgcolor): 
+        code.append('3'+colors[fgcolor])
+    if (bgcolor): 
+        code.append("4"+colors[bgcolor])
+    return "".join(("\033[", ';'.join(code), "m", text, "\033[0m"))
+
+def term_title(title):
+    term = os.environ.get('TERM', '')
+    if term.startswith('xterm') or term == 'dtterm':
+        return "\033]0;%s\007" % title
+    return str()
+
+
+# arch-tag: a79b9993-146e-4a51-8bae-a13791703ddd

